alg_order(alg::AitkenNeville) = alg.init_order
alg_maximum_order(alg::ExtrapolationMidpointDeuflhard) = 2(alg.max_order + 1)

function get_current_adaptive_order(
        alg::OrdinaryDiffEqExtrapolationVarOrderVarStepAlgorithm,
        cache
    )
    return cache.cur_order
end
function get_current_alg_order(
        alg::OrdinaryDiffEqExtrapolationVarOrderVarStepAlgorithm,
        cache
    )
    return cache.cur_order
end
get_current_alg_order(alg::ExtrapolationMidpointDeuflhard, cache) = 2(cache.n_curr + 1)
get_current_alg_order(alg::ImplicitDeuflhardExtrapolation, cache) = 2(cache.n_curr + 1)
get_current_adaptive_order(alg::ExtrapolationMidpointDeuflhard, cache) = 2cache.n_curr
get_current_adaptive_order(alg::ImplicitDeuflhardExtrapolation, cache) = 2cache.n_curr
get_current_alg_order(alg::ExtrapolationMidpointHairerWanner, cache) = 2(cache.n_curr + 1)
get_current_alg_order(alg::ImplicitHairerWannerExtrapolation, cache) = 2(cache.n_curr + 1)
get_current_alg_order(alg::ImplicitEulerBarycentricExtrapolation, cache) = cache.n_curr
get_current_alg_order(alg::ImplicitEulerExtrapolation, cache) = cache.n_curr + 1
get_current_adaptive_order(alg::ExtrapolationMidpointHairerWanner, cache) = 2cache.n_curr
get_current_adaptive_order(alg::ImplicitHairerWannerExtrapolation, cache) = 2cache.n_curr
get_current_adaptive_order(alg::ImplicitEulerExtrapolation, cache) = cache.n_curr - 1
function get_current_adaptive_order(
        alg::ImplicitEulerBarycentricExtrapolation, cache
    )
    return cache.n_curr - 2
end

alg_maximum_order(alg::ImplicitDeuflhardExtrapolation) = 2(alg.max_order + 1)
alg_maximum_order(alg::ExtrapolationMidpointHairerWanner) = 2(alg.max_order + 1)
alg_maximum_order(alg::ImplicitHairerWannerExtrapolation) = 2(alg.max_order + 1)
alg_maximum_order(alg::ImplicitEulerExtrapolation) = 2(alg.max_order + 1)
alg_maximum_order(alg::ImplicitEulerBarycentricExtrapolation) = alg.max_order

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        function legacy_default_controller(
                alg::Union{
                    ExtrapolationMidpointDeuflhard,
                    ImplicitDeuflhardExtrapolation,
                    ExtrapolationMidpointHairerWanner,
                    ImplicitHairerWannerExtrapolation,
                    ImplicitEulerExtrapolation,
                    ImplicitEulerBarycentricExtrapolation,
                },
                cache,
                qoldinit, _beta1 = nothing, _beta2 = nothing
            )
            QT = typeof(qoldinit)
            beta1, beta2 = _digest_beta1_beta2(alg, cache, Val(QT), _beta1, _beta2)
            return ExtrapolationController(beta1)
        end

        function default_controller_v7(
                QT,
                alg::Union{
                    ExtrapolationMidpointDeuflhard,
                    ImplicitDeuflhardExtrapolation,
                    ExtrapolationMidpointHairerWanner,
                    ImplicitHairerWannerExtrapolation,
                    ImplicitEulerExtrapolation,
                    ImplicitEulerBarycentricExtrapolation,
                }
            )
            return NewExtrapolationController(QT, alg)
        end

        # FIXME AitkenNeville is missing integration with the extrapolation controller and picks up the PI controller instead.
        function legacy_default_controller(
                alg::AitkenNeville,
                cache,
                qoldinit, _beta1 = nothing, _beta2 = nothing
            )
            QT = typeof(qoldinit)
            beta1, beta2 = _digest_beta1_beta2(alg, cache, Val(QT), _beta1, _beta2)
            return PIController(beta1, beta2)
        end
        function default_controller_v7(QT, alg::AitkenNeville)
            beta2 = QT(beta2_default(alg))
            beta1 = QT(beta1_default(alg, beta2))
            return PIController(beta1, beta2)
        end
    end
else
    @eval begin
        function default_controller(
                alg::Union{
                    ExtrapolationMidpointDeuflhard,
                    ImplicitDeuflhardExtrapolation,
                    ExtrapolationMidpointHairerWanner,
                    ImplicitHairerWannerExtrapolation,
                    ImplicitEulerExtrapolation,
                    ImplicitEulerBarycentricExtrapolation,
                },
                cache,
                qoldinit, _beta1 = nothing, _beta2 = nothing
            )
            QT = typeof(qoldinit)
            beta1, beta2 = _digest_beta1_beta2(alg, cache, Val(QT), _beta1, _beta2)
            return ExtrapolationController(beta1)
        end
        # FIXME AitkenNeville is missing integration with the extrapolation controller and picks up the PI controller instead.
        function default_controller(
                alg::AitkenNeville,
                cache,
                qoldinit, _beta1 = nothing, _beta2 = nothing
            )
            QT = typeof(qoldinit)
            beta1, beta2 = _digest_beta1_beta2(alg, cache, Val(QT), _beta1, _beta2)
            return PIController(beta1, beta2)
        end
    end
end

beta2_default(alg::ExtrapolationMidpointDeuflhard) = 0 // 1
beta2_default(alg::ImplicitDeuflhardExtrapolation) = 0 // 1
beta2_default(alg::ExtrapolationMidpointHairerWanner) = 0 // 1
beta2_default(alg::ImplicitHairerWannerExtrapolation) = 0 // 1
beta2_default(alg::ImplicitEulerExtrapolation) = 0 // 1
beta2_default(alg::ImplicitEulerBarycentricExtrapolation) = 0 // 1

beta1_default(alg::ExtrapolationMidpointDeuflhard, beta2) = 1 // (2alg.init_order + 1)
beta1_default(alg::ImplicitDeuflhardExtrapolation, beta2) = 1 // (2alg.init_order + 1)
beta1_default(alg::ExtrapolationMidpointHairerWanner, beta2) = 1 // (2alg.init_order + 1)
beta1_default(alg::ImplicitHairerWannerExtrapolation, beta2) = 1 // (2alg.init_order + 1)
beta1_default(alg::ImplicitEulerExtrapolation, beta2) = 1 // (alg.init_order + 1)
beta1_default(alg::ImplicitEulerBarycentricExtrapolation, beta2) = 1 // (alg.init_order - 1)

function gamma_default(alg::ExtrapolationMidpointDeuflhard)
    return (1 // 4)^beta1_default(alg, beta2_default(alg))
end
function gamma_default(alg::ImplicitDeuflhardExtrapolation)
    return (1 // 4)^beta1_default(alg, beta2_default(alg))
end
function gamma_default(alg::ExtrapolationMidpointHairerWanner)
    return (65 // 100)^beta1_default(alg, beta2_default(alg))
end
function gamma_default(alg::ImplicitHairerWannerExtrapolation)
    return (65 // 100)^beta1_default(alg, beta2_default(alg))
end
function gamma_default(alg::ImplicitEulerExtrapolation)
    return (65 // 100)^beta1_default(alg, beta2_default(alg))
end

function gamma_default(alg::ImplicitEulerBarycentricExtrapolation)
    return (80 // 100)^beta1_default(alg, beta2_default(alg))
end

module OrdinaryDiffEqExtrapolation

import OrdinaryDiffEqCore: alg_order, alg_maximum_order, get_current_adaptive_order,
    get_current_alg_order, calculate_residuals!,
    accept_step_controller,
    beta2_default, beta1_default, gamma_default,
    initialize!, perform_step!, @cache, unwrap_alg,
    isthreaded, isadaptive, PIController,
    step_accept_controller!, calculate_residuals,
    OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
    reset_alg_dependent_opts!, AbstractController,
    step_accept_controller!, step_reject_controller!,
    OrdinaryDiffEqAdaptiveAlgorithm,
    OrdinaryDiffEqAdaptiveImplicitAlgorithm,
    alg_cache, CompiledFloats, @threaded, stepsize_controller!,
    DEFAULT_PRECS, full_cache, qmin_default, qmax_default,
    constvalue, PolyesterThreads, Sequential, BaseThreads,
    _digest_beta1_beta2, timedepentdtmin, _unwrap_val,
    _reshape, _vec, get_fsalfirstlast, generic_solver_docstring,
    differentiation_rk_docstring, _bool_to_ADType,
    _process_AD_choice, LinearAliasSpecifier, @SciMLMessage, Minimal

using FastBroadcast, Polyester, MuladdMacro, RecursiveArrayTools, LinearSolve
import OrdinaryDiffEqCore
import FastPower
import OrdinaryDiffEqDifferentiation: TimeDerivativeWrapper, UDerivativeWrapper, calc_J,
    WOperator, TimeGradientWrapper, UJacobianWrapper,
    build_grad_config,
    build_jac_config, calc_J!, jacobian2W!, dolinsolve
import ADTypes: AutoForwardDiff, AbstractADType

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        import OrdinaryDiffEqCore: AbstractLegacyController, default_controller_v7,
            legacy_default_controller, setup_controller_cache, AbstractControllerCache
    end
else
    @eval begin
        import OrdinaryDiffEqCore: default_controller
    end
end

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("controllers.jl")
include("extrapolation_caches.jl")
include("extrapolation_perform_step.jl")

@inline function SciMLBase.get_tmp_cache(
        integrator,
        alg::OrdinaryDiffEqImplicitExtrapolationAlgorithm,
        cache::OrdinaryDiffEqMutableCache
    )
    return (cache.tmp, cache.utilde)
end

export AitkenNeville, ExtrapolationMidpointDeuflhard, ExtrapolationMidpointHairerWanner,
    ImplicitEulerExtrapolation,
    ImplicitDeuflhardExtrapolation, ImplicitHairerWannerExtrapolation,
    ImplicitEulerBarycentricExtrapolation

end

function initialize!(integrator, cache::AitkenNevilleCache)
    integrator.kshortsize = 2
    (; k, fsalfirst) = cache

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    cache.step_no = 1
    alg = unwrap_alg(integrator, false)
    return cache.cur_order = max(alg.init_order, alg.min_order)
end

function perform_step!(integrator, cache::AitkenNevilleCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; k, fsalfirst, T, utilde, atmp, dtpropose, cur_order, A) = cache
    (; u_tmps, k_tmps) = cache

    max_order = min(size(T, 1), cur_order + 1)

    if !isthreaded(alg.threading)
        for i in 1:max_order
            dt_temp = dt / (2^(i - 1))
            # Solve using Euler method
            @muladd @.. broadcast = false u = uprev + dt_temp * fsalfirst
            f(k, u, p, t + dt_temp)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            for j in 2:(2^(i - 1))
                @muladd @.. broadcast = false u = u + dt_temp * k
                f(k, u, p, t + j * dt_temp)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            end
            @.. broadcast = false T[i, 1] = u
        end
    else
        let max_order = max_order, uprev = uprev, dt = dt, fsalfirst = fsalfirst, p = p,
                t = t, u_tmps = u_tmps, k_tmps = k_tmps, T = T
            # Balance workload of threads by computing T[1,1] with T[max_order,1] on
            # same thread, T[2,1] with T[max_order-1,1] on same thread. Similarly fill
            # first column of T matrix
            @threaded alg.threading for i in 1:2
                startIndex = (i == 1) ? 1 : max_order
                endIndex = (i == 1) ? max_order - 1 : max_order
                for index in startIndex:endIndex
                    dt_temp = dt / (2^(index - 1))
                    # Solve using Euler method
                    @muladd @.. broadcast = false u_tmps[Threads.threadid()] = uprev +
                        dt_temp *
                        fsalfirst
                    f(
                        k_tmps[Threads.threadid()], u_tmps[Threads.threadid()], p,
                        t + dt_temp
                    )
                    for j in 2:(2^(index - 1))
                        @muladd @.. broadcast = false u_tmps[Threads.threadid()] = u_tmps[Threads.threadid()] +
                            dt_temp *
                            k_tmps[Threads.threadid()]
                        f(
                            k_tmps[Threads.threadid()], u_tmps[Threads.threadid()], p,
                            t + j * dt_temp
                        )
                    end
                    @.. broadcast = false T[index, 1] = u_tmps[Threads.threadid()]
                end
            end
        end
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)^max_order - 1
    end

    # Richardson extrapolation
    tmp = 1
    for j in 2:max_order
        tmp *= 2
        for i in j:max_order
            @.. broadcast = false T[i, j] = (tmp * T[i, j - 1] - T[i - 1, j - 1]) / (tmp - 1)
        end
    end

    if integrator.opts.adaptive
        minimum_work = Inf
        if isone(cache.step_no)
            range_start = 2
        else
            range_start = max(2, cur_order - 1)
        end

        for i in range_start:max_order
            A = 2^(i - 1)
            @.. broadcast = false utilde = T[i, i] - T[i, i - 1]
            # FIXME this should be stored in the controller cache
            atmp = calculate_residuals(
                utilde, uprev, T[i, i], integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            EEst = integrator.opts.internalnorm(atmp, t)

            beta1 = integrator.opts.controller.beta1
            e = integrator.EEst
            qold = integrator.qold

            integrator.opts.controller.beta1 = 1 / (i + 1)
            integrator.EEst = EEst
            dtpropose = step_accept_controller!(
                integrator, alg,
                stepsize_controller!(integrator, alg)
            )
            integrator.EEst = e
            integrator.opts.controller.beta1 = beta1
            integrator.qold = qold

            work = A / dtpropose

            if work < minimum_work
                integrator.opts.controller.beta1 = 1 / (i + 1)
                cache.dtpropose = dtpropose
                cache.cur_order = i
                minimum_work = work
                integrator.EEst = EEst
            end
        end
    end

    # using extrapolated value of u
    @.. broadcast = false u = T[cache.cur_order, cache.cur_order]
    cache.step_no = cache.step_no + 1
    f(k, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::AitkenNevilleConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    cache.step_no = 1
    alg = unwrap_alg(integrator, false)
    return cache.cur_order = max(alg.init_order, alg.min_order)
end

function perform_step!(integrator, cache::AitkenNevilleConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; dtpropose, T, cur_order, work, A) = cache

    max_order = min(size(T, 1), cur_order + 1)

    if !isthreaded(alg.threading)
        for i in 1:max_order
            dt_temp = dt / (2^(i - 1)) # Romberg sequence

            # Solve using Euler method with dt_temp = dt/n_{i}
            @muladd u = @.. broadcast = false uprev + dt_temp * integrator.fsalfirst
            k = f(u, p, t + dt_temp)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

            for j in 2:(2^(i - 1))
                @muladd u = @.. broadcast = false u + dt_temp * k
                k = f(u, p, t + j * dt_temp)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            end
            T[i, 1] = u
        end
    else
        let max_order = max_order, dt = dt, uprev = uprev, integrator = integrator, p = p,
                t = t, T = T
            # Balance workload of threads by computing T[1,1] with T[max_order,1] on
            # same thread, T[2,1] with T[max_order-1,1] on same thread. Similarly fill
            # first column of T matrix
            @threaded alg.threading for i in 1:2
                startIndex = (i == 1) ? 1 : max_order
                endIndex = (i == 1) ? max_order - 1 : max_order

                for index in startIndex:endIndex
                    dt_temp = dt / 2^(index - 1)
                    @muladd u = @.. broadcast = false uprev + dt_temp * integrator.fsalfirst
                    k_temp = f(u, p, t + dt_temp)
                    for j in 2:(2^(index - 1))
                        @muladd u = @.. broadcast = false u + dt_temp * k_temp
                        k_temp = f(u, p, t + j * dt_temp)
                    end
                    T[index, 1] = u
                end
            end
        end

        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)^max_order - 1
    end

    # Richardson extrapolation
    tmp = 1
    for j in 2:max_order
        tmp *= 2
        for i in j:max_order
            T[i, j] = (tmp * T[i, j - 1] - T[i - 1, j - 1]) / (tmp - 1)
        end
    end

    if integrator.opts.adaptive
        minimum_work = Inf
        if isone(cache.step_no)
            range_start = 2
        else
            range_start = max(2, cur_order - 1)
        end

        for i in range_start:max_order
            A = 2^(i - 1)
            utilde = T[i, i] - T[i, i - 1]
            # FIXME this should be stored in the controller cache
            atmp = calculate_residuals(
                utilde, uprev, T[i, i], integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            EEst = integrator.opts.internalnorm(atmp, t)

            beta1 = integrator.opts.controller.beta1
            e = integrator.EEst
            qold = integrator.qold

            integrator.opts.controller.beta1 = 1 / (i + 1)
            integrator.EEst = EEst
            dtpropose = step_accept_controller!(
                integrator, alg,
                stepsize_controller!(integrator, alg)
            )
            integrator.EEst = e
            integrator.opts.controller.beta1 = beta1
            integrator.qold = qold

            work = A / dtpropose

            if work < minimum_work
                integrator.opts.controller.beta1 = 1 / (i + 1)
                cache.dtpropose = dtpropose
                cache.cur_order = i
                minimum_work = work
                integrator.EEst = EEst
            end
        end
    end

    cache.step_no = cache.step_no + 1

    # Use extrapolated value of u
    integrator.u = T[cache.cur_order, cache.cur_order]

    k = f(integrator.u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = k
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function initialize!(integrator, cache::ImplicitEulerExtrapolationCache)
    integrator.kshortsize = 2
    integrator.f(integrator.fsalfirst, integrator.u, integrator.p, integrator.t)
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    return cache.step_no = 1
    #alg = unwrap_alg(integrator, true)
    #cache.cur_order = max(alg.init_order, alg.min_order)
end

function perform_step!(
        integrator, cache::ImplicitEulerExtrapolationCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; T, utilde, atmp, dtpropose, n_curr, A, stage_number, diff1, diff2) = cache
    (; J, W, uf, tf, jac_config) = cache
    (; u_tmps, k_tmps, linsolve_tmps, u_tmps2) = cache

    (; sequence) = cache

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    if !isthreaded(alg.threading)
        calc_J!(J, integrator, cache) # Store the calculated jac as it won't change in internal discretisation
        for index in 1:(n_curr + 1)
            dt_temp = dt / sequence[index]
            jacobian2W!(W[1], integrator.f.mass_matrix, dt_temp, J)
            integrator.stats.nw += 1
            @.. broadcast = false k_tmps[1] = integrator.fsalfirst
            @.. broadcast = false u_tmps[1] = uprev

            for j in 1:sequence[index]
                @.. broadcast = false linsolve_tmps[1] = k_tmps[1]

                linsolve = cache.linsolve[1]

                if !repeat_step && j == 1
                    linres = dolinsolve(
                        integrator, linsolve; A = W[1],
                        b = _vec(linsolve_tmps[1]), linu = _vec(k_tmps[1])
                    )
                else
                    linres = dolinsolve(
                        integrator, linsolve; A = nothing,
                        b = _vec(linsolve_tmps[1]), linu = _vec(k_tmps[1])
                    )
                end

                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false u_tmps2[1] = u_tmps[1]
                @.. broadcast = false u_tmps[1] = u_tmps[1] - k_tmps[1]
                if index <= 2 && j >= 2
                    # Deuflhard Stability check for initial two sequences
                    @.. broadcast = false diff2[1] = u_tmps[1] - u_tmps2[1]
                    @.. broadcast = false diff2[1] = 0.5 * (diff2[1] - diff1[1])
                    norm_diff1 = integrator.opts.internalnorm(diff1[1], t)
                    norm_diff2 = integrator.opts.internalnorm(diff2[1], t)
                    if norm_diff1 < norm_diff2
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        @SciMLMessage(
                            lazy"Deuflhard stability check failed: ||diff1|| = $(norm_diff1) < ||diff2|| = $(norm_diff2), divergence detected",
                            integrator.opts.verbose, :stability_check
                        )
                        integrator.force_stepfail = true
                        return
                    end
                end
                @.. broadcast = false diff1[1] = u_tmps[1] - u_tmps2[1]

                f(k_tmps[1], u_tmps[1], p, t + j * dt_temp)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            end

            @.. broadcast = false T[index, 1] = u_tmps[1]
        end
    else
        calc_J!(J, integrator, cache) # Store the calculated jac as it won't change in internal discretisation
        let n_curr = n_curr, uprev = uprev, dt = dt, p = p, t = t, T = T, W = W,
                integrator = integrator, cache = cache, repeat_step = repeat_step,
                k_tmps = k_tmps, u_tmps = u_tmps, u_tmps2 = u_tmps2, diff1 = diff1,
                diff2 = diff2

            @threaded alg.threading for i in 1:2
                startIndex = (i == 1) ? 1 : n_curr + 1
                endIndex = (i == 1) ? n_curr : n_curr + 1
                for index in startIndex:endIndex
                    dt_temp = dt / sequence[index]
                    jacobian2W!(W[Threads.threadid()], integrator.f.mass_matrix, dt_temp, J)
                    @.. broadcast = false k_tmps[Threads.threadid()] = integrator.fsalfirst
                    @.. broadcast = false u_tmps[Threads.threadid()] = uprev
                    for j in 1:sequence[index]
                        @.. broadcast = false linsolve_tmps[Threads.threadid()] = k_tmps[Threads.threadid()]

                        linsolve = cache.linsolve[Threads.threadid()]

                        if !repeat_step && j == 1
                            linres = dolinsolve(
                                integrator, linsolve;
                                A = W[Threads.threadid()],
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        end

                        cache.linsolve[Threads.threadid()] = linres.cache

                        @.. broadcast = false u_tmps2[Threads.threadid()] = u_tmps[Threads.threadid()]
                        @.. broadcast = false u_tmps[Threads.threadid()] = u_tmps[Threads.threadid()] -
                            k_tmps[Threads.threadid()]
                        if index <= 2 && j >= 2
                            # Deuflhard Stability check for initial two sequences
                            @.. broadcast = false diff2[Threads.threadid()] = u_tmps[Threads.threadid()] -
                                u_tmps2[Threads.threadid()]
                            @.. broadcast = false diff2[Threads.threadid()] = 0.5 *
                                (
                                diff2[Threads.threadid()] -
                                    diff1[Threads.threadid()]
                            )
                            if integrator.opts.internalnorm(diff1[Threads.threadid()], t) <
                                    integrator.opts.internalnorm(diff2[Threads.threadid()], t)
                                # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                integrator.force_stepfail = true
                                return
                            end
                        end
                        @.. broadcast = false diff1[Threads.threadid()] = u_tmps[Threads.threadid()] -
                            u_tmps2[Threads.threadid()]
                        f(
                            k_tmps[Threads.threadid()], u_tmps[Threads.threadid()], p,
                            t + j * dt_temp
                        )
                    end

                    @.. broadcast = false T[index, 1] = u_tmps[Threads.threadid()]
                end
                integrator.force_stepfail ? break : continue
            end
        end

        nevals = sum(sequence[1:(n_curr + 1)]) - 1
        integrator.stats.nw += n_curr + 1
        integrator.stats.nf += nevals
        integrator.stats.nsolve += nevals
    end

    if integrator.force_stepfail
        return
    end

    # Polynomial extrapolation
    for j in 2:(n_curr + 1)
        for i in j:(n_curr + 1)
            @.. broadcast = false T[i, j] = (
                (sequence[i] / sequence[i - j + 1]) * T[
                    i, j - 1,
                ] -
                    T[i - 1, j - 1]
            ) /
                ((sequence[i] / sequence[i - j + 1]) - 1)
        end
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min
            @.. broadcast = false integrator.u = T[i + 1, i + 1]
            @.. broadcast = false cache.utilde = T[i + 1, i]

            calculate_residuals!(
                cache.atmp, integrator.u, cache.utilde,
                integrator.opts.abstol, integrator.opts.reltol,
                integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) ||
                    integrator.EEst <=
                    typeof(integrator.EEst)(
                    prod(
                        sequence[(n_curr + 2):(win_max + 1)] .//
                            sequence[1]^2
                    )
                )
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                dt_temp = dt / sequence[n_curr + 1]
                jacobian2W!(W[1], integrator.f.mass_matrix, dt_temp, J)
                integrator.stats.nw += 1
                @.. broadcast = false k_tmps[1] = integrator.fsalfirst
                @.. broadcast = false u_tmps[1] = uprev

                for j in 1:sequence[n_curr + 1]
                    @.. broadcast = false linsolve_tmps[1] = k_tmps[1]

                    linsolve = cache.linsolve[1]

                    if !repeat_step && j == 1
                        linres = dolinsolve(
                            integrator, linsolve; A = W[1],
                            b = _vec(linsolve_tmps[1]),
                            linu = _vec(k_tmps[1])
                        )
                    else
                        linres = dolinsolve(
                            integrator, linsolve; A = nothing,
                            b = _vec(linsolve_tmps[1]),
                            linu = _vec(k_tmps[1])
                        )
                    end

                    cache.linsolve[1] = linres.cache

                    integrator.stats.nsolve += 1
                    @.. broadcast = false u_tmps[1] = u_tmps[1] - k_tmps[1]
                    f(k_tmps[1], u_tmps[1], p, t + j * dt_temp)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                end

                @.. broadcast = false T[n_curr + 1, 1] = u_tmps[1]

                for j in 2:(n_curr + 1)
                    for i in j:(n_curr + 1)
                        @.. broadcast = false T[i, j] = (
                            (sequence[i] / sequence[i - j + 1]) *
                                T[i, j - 1] - T[i - 1, j - 1]
                        ) /
                            (
                            (sequence[i] / sequence[i - j + 1]) -
                                1
                        )
                    end
                end

                @.. broadcast = false integrator.u = T[n_curr + 1, n_curr + 1]
                @.. broadcast = false cache.utilde = T[n_curr + 1, n_curr]

                calculate_residuals!(
                    cache.atmp, integrator.u, cache.utilde,
                    integrator.opts.abstol, integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        @.. broadcast = false integrator.u = T[n_curr + 1, n_curr + 1]
    end

    cache.step_no = cache.step_no + 1
    f(integrator.fsallast, integrator.u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ImplicitEulerExtrapolationConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function perform_step!(
        integrator, cache::ImplicitEulerExtrapolationConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; dtpropose, T, n_curr, work, A, tf, uf) = cache
    (; sequence, stage_number) = cache

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    J = calc_J(integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for index in 1:(n_curr + 1)
            dt_temp = dt / sequence[index]
            W = dt_temp * J - integrator.f.mass_matrix
            integrator.stats.nw += 1
            k_copy = integrator.fsalfirst
            u_tmp = uprev
            diff1 = zero(u_tmp)
            for j in 1:sequence[index]
                k = _reshape(W \ -_vec(dt_temp * k_copy), axes(uprev))
                integrator.stats.nsolve += 1
                u_tmp2 = u_tmp
                u_tmp = u_tmp + k
                if index <= 2 && j >= 2
                    # Deuflhard Stability check for initial two sequences
                    diff2 = u_tmp - u_tmp2
                    diff2 = 0.5 * (diff2 - diff1)
                    if integrator.opts.internalnorm(diff1, t) <
                            integrator.opts.internalnorm(diff2, t)
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
                diff1 = u_tmp - u_tmp2
                k_copy = f(u_tmp, p, t + j * dt_temp)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            end

            T[index, 1] = u_tmp
        end
    else
        J = calc_J(integrator, cache) # Store the calculated jac as it won't change in internal discretisation
        let n_curr = n_curr, dt = dt, integrator = integrator, cache = cache,
                repeat_step = repeat_step, uprev = uprev, T = T

            @threaded alg.threading for i in 1:2
                startIndex = (i == 1) ? 1 : n_curr + 1
                endIndex = (i == 1) ? n_curr : n_curr + 1
                for index in startIndex:endIndex
                    dt_temp = dt / sequence[index]
                    W = dt_temp * J - integrator.f.mass_matrix
                    k_copy = integrator.fsalfirst
                    u_tmp = uprev
                    diff1 = zero(u_tmp)
                    for j in 1:sequence[index]
                        k = _reshape(W \ -_vec(dt_temp * k_copy), axes(uprev))
                        u_tmp2 = u_tmp
                        u_tmp = u_tmp + k
                        if index <= 2 && j >= 2
                            # Deuflhard Stability check for initial two sequences
                            diff2 = u_tmp - u_tmp2
                            diff2 = 0.5 * (diff2 - diff1)
                            if integrator.opts.internalnorm(diff1, t) <
                                    integrator.opts.internalnorm(diff2, t)
                                # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                integrator.force_stepfail = true
                                return
                            end
                        end
                        diff1 = u_tmp - u_tmp2
                        k_copy = f(u_tmp, p, t + j * dt_temp)
                    end
                    T[index, 1] = u_tmp
                end
                integrator.force_stepfail ? break : continue
            end
        end

        if integrator.force_stepfail
            return
        end

        nevals = sum(sequence[1:(n_curr + 1)]) - 1
        integrator.stats.nw += n_curr + 1
        integrator.stats.nf += nevals
        integrator.stats.nsolve += nevals
    end

    # Richardson extrapolation
    tmp = 1
    for j in 2:(n_curr + 1)
        tmp *= 2
        for i in j:(n_curr + 1)
            T[i, j] = (
                (sequence[i] / sequence[i - j + 1]) * T[i, j - 1] -
                    T[i - 1, j - 1]
            ) /
                ((sequence[i] / sequence[i - j + 1]) - 1)
        end
    end

    integrator.dt = dt

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min
            u = T[i + 1, i + 1]
            utilde = T[i + 1, i]
            # FIXME this should be stored in the controller cache
            res = calculate_residuals(
                u, utilde, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(res, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) ||
                    integrator.EEst <=
                    typeof(integrator.EEst)(
                    prod(
                        sequence[(n_curr + 2):(win_max + 1)] .//
                            sequence[1]^2
                    )
                )
                # Reject current approximation order but pass convergence monitor
                # Always compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update T
                dt_temp = dt / sequence[n_curr + 1]
                W = dt_temp * J - integrator.f.mass_matrix
                integrator.stats.nw += 1
                k_copy = integrator.fsalfirst
                u_tmp = uprev

                for j in 1:sequence[n_curr + 1]
                    k = _reshape(W \ -_vec(dt_temp * k_copy), axes(uprev))
                    integrator.stats.nsolve += 1
                    u_tmp = u_tmp + k
                    k_copy = f(u_tmp, p, t + j * dt_temp)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                end

                T[n_curr + 1, 1] = u_tmp

                #Extrapolate to new order
                for j in 2:(n_curr + 1)
                    for i in j:(n_curr + 1)
                        T[i, j] = (
                            (sequence[i] / sequence[i - j + 1]) * T[i, j - 1] -
                                T[i - 1, j - 1]
                        ) /
                            ((sequence[i] / sequence[i - j + 1]) - 1)
                    end
                end
                # Update u, integrator.EEst and cache.Q
                u = T[n_curr + 1, n_curr + 1]
                utilde = T[n_curr + 1, n_curr]
                # FIXME this should be stored in the controller cache
                res = calculate_residuals(
                    u, utilde, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(res, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        integrator.u = T[n_curr + 1, n_curr + 1]
    end

    # Use extrapolated value of u
    integrator.u = T[n_curr + 1, n_curr + 1]
    k_temp = f(integrator.u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = k_temp
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function initialize!(integrator, cache::ExtrapolationMidpointDeuflhardCache)
    # cf. initialize! of MidpointCache
    (; k, fsalfirst) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
end

function perform_step!(
        integrator, cache::ExtrapolationMidpointDeuflhardCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; n_curr, u_temp1, u_temp2, utilde, T, fsalfirst, k) = cache
    (; u_temp3, u_temp4, k_tmps) = cache

    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; stage_number) = cache
    (; sequence_factor) = alg

    fill!(cache.Q, zero(eltype(cache.Q)))
    tol = integrator.opts.internalnorm(integrator.opts.reltol, t) # Used by the convergence monitor

    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        win_min = max(alg.min_order, n_curr - 1)
        win_max = min(alg.max_order, n_curr + 1)

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = sequence_factor * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            @.. broadcast = false u_temp2 = uprev
            @.. broadcast = false u_temp1 = u_temp2 + dt_int * fsalfirst # Euler starting step
            for j in 2:j_int
                f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                @.. broadcast = false T[i + 1] = u_temp2 + 2 * dt_int * k # Explicit Midpoint rule
                @.. broadcast = false u_temp2 = u_temp1
                @.. broadcast = false u_temp1 = T[i + 1]
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr
                    for index in startIndex:endIndex
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] +
                            dt_int_temp *
                            fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false T[index + 1] = u_temp4[Threads.threadid()] +
                                2 * dt_int_temp *
                                k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                        end
                    end
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = (i, n_curr - i)
                    for index in indices
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] +
                            dt_int_temp *
                            fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            f(
                                k_tmps[Threads.threadid()], u_temp3[Threads.threadid()], p,
                                t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false T[index + 1] = u_temp4[Threads.threadid()] +
                                2 * dt_int_temp *
                                k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                        end
                        if indices[2] <= indices[1]
                            break
                        end
                    end
                end
            end
        end
        nevals = cache.stage_number[n_curr - alg.min_order + 1] - 1
        integrator.stats.nf += nevals
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (alg.min_order):n_curr

            #integrator.u .= extrapolation_scalars[i+1] * sum( broadcast(*, cache.T[1:(i+1)], extrapolation_weights[1:(i+1), (i+1)]) ) # Approximation of extrapolation order i
            #cache.utilde .= extrapolation_scalars_2[i] * sum( broadcast(*, cache.T[2:(i+1)], extrapolation_weights_2[1:i, i]) ) # and its internal counterpart

            u_temp1 .= false
            u_temp2 .= false
            for j in 1:(i + 1)
                @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (i + 1)]
            end
            for j in 2:(i + 1)
                @.. broadcast = false u_temp2 += cache.T[j] * extrapolation_weights_2[j - 1, i]
            end
            @.. broadcast = false integrator.u = extrapolation_scalars[i + 1] * u_temp1
            @.. broadcast = false cache.utilde = extrapolation_scalars_2[i] * u_temp2

            calculate_residuals!(
                cache.atmp, integrator.u, cache.utilde,
                integrator.opts.abstol, integrator.opts.reltol,
                integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif integrator.EEst <=
                    tol^(
                    stage_number[n_curr - alg.min_order + 1] /
                        stage_number[win_max - alg.min_order + 1] - 1
                )
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update cache.T
                j_int = sequence_factor * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                @.. broadcast = false u_temp2 = uprev
                @.. broadcast = false u_temp1 = u_temp2 + dt_int * fsalfirst # Euler starting step
                for j in 2:j_int
                    f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    @.. broadcast = false T[n_curr + 1] = u_temp2 + 2 * dt_int * k
                    @.. broadcast = false u_temp2 = u_temp1
                    @.. broadcast = false u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
                #cache.utilde .= extrapolation_scalars_2[n_curr] * sum( broadcast(*, cache.T[2:(n_curr+1)], extrapolation_weights_2[1:n_curr, n_curr]) ) # and its internal counterpart

                u_temp1 .= false
                u_temp2 .= false
                for j in 1:(n_curr + 1)
                    @.. broadcast = false u_temp1 += cache.T[j] *
                        extrapolation_weights[j, (n_curr + 1)]
                end
                for j in 2:(n_curr + 1)
                    @.. broadcast = false u_temp2 += cache.T[j] *
                        extrapolation_weights_2[j - 1, n_curr]
                end
                @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
                @.. broadcast = false cache.utilde = extrapolation_scalars_2[n_curr] * u_temp2

                calculate_residuals!(
                    cache.atmp, integrator.u, cache.utilde,
                    integrator.opts.abstol, integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else

        #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
        u_temp1 .= false
        for j in 1:(n_curr + 1)
            @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (n_curr + 1)]
        end
        @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
    end

    f(cache.k, integrator.u, p, t + dt) # Update FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ExtrapolationMidpointDeuflhardConstantCache)
    # cf. initialize! of MidpointConstantCache
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function perform_step!(
        integrator, cache::ExtrapolationMidpointDeuflhardConstantCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; n_curr) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; stage_number) = cache
    (; sequence_factor) = alg

    # Create auxiliary variables
    u_temp1, u_temp2 = copy(uprev), copy(uprev) # Auxiliary variables for computing the internal discretisations
    u, utilde = copy(uprev), copy(uprev) # Storage for the latest approximation and its internal counterpart
    tol = integrator.opts.internalnorm(integrator.opts.reltol, t) # Used by the convergence monitor
    T = fill(zero(uprev), alg.max_order + 1) # Storage for the internal discretisations obtained by the explicit midpoint rule
    fill!(cache.Q, zero(eltype(cache.Q)))

    # Start computation
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        win_min = max(alg.min_order, n_curr - 1)
        win_max = min(alg.max_order, n_curr + 1)

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    # Compute the internal discretisations
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = sequence_factor * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            u_temp2 = uprev
            u_temp1 = u_temp2 + dt_int * integrator.fsalfirst # Euler starting step
            for j in 2:j_int
                T[i + 1] = u_temp2 + 2 * dt_int * f(u_temp1, p, t + (j - 1) * dt_int) # Explicit Midpoint rule
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                u_temp2 = u_temp1
                u_temp1 = T[i + 1]
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, integrator = integrator, p = p, t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr
                    for index in startIndex:endIndex
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        u_temp4 = uprev
                        u_temp3 = u_temp4 + dt_int_temp * integrator.fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            T[index + 1] = u_temp4 +
                                2 * dt_int_temp *
                                f(u_temp3, p, t + (j - 1) * dt_int_temp) # Explicit Midpoint rule
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                        end
                    end
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, dt = dt,
                    uprev = uprev, p = p, t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = (i, n_curr - i)
                    for index in indices
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        u_temp4 = uprev
                        u_temp3 = u_temp4 + dt_int_temp * integrator.fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            T[index + 1] = u_temp4 +
                                2 * dt_int_temp *
                                f(u_temp3, p, t + (j - 1) * dt_int_temp) # Explicit Midpoint rule
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                        end
                        if indices[2] <= indices[1]
                            break
                        end
                    end
                end
            end
        end
        nevals = cache.stage_number[n_curr - alg.min_order + 1] - 1
        integrator.stats.nf += nevals
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (alg.min_order):n_curr
            u = eltype(uprev).(extrapolation_scalars[i + 1]) *
                sum(
                broadcast(
                    *, T[1:(i + 1)],
                    eltype(uprev).(extrapolation_weights[1:(i + 1), (i + 1)])
                )
            ) # Approximation of extrapolation order i
            utilde = eltype(uprev).(extrapolation_scalars_2[i]) *
                sum(
                broadcast(
                    *, T[2:(i + 1)],
                    eltype(uprev).(extrapolation_weights_2[1:i, i])
                )
            ) # and its internal counterpart
            # FIXME this should be stored in the controller cache
            res = calculate_residuals(
                u, utilde, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(res, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif integrator.EEst <=
                    tol^(
                    stage_number[n_curr - alg.min_order + 1] /
                        stage_number[win_max - alg.min_order + 1] - 1
                )
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update T
                j_int = sequence_factor * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                u_temp2 = uprev
                u_temp1 = u_temp2 + dt_int * integrator.fsalfirst # Euler starting step
                for j in 2:j_int
                    T[n_curr + 1] = u_temp2 +
                        2 * dt_int * f(u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    u_temp2 = u_temp1
                    u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
                    sum(
                    broadcast(
                        *, T[1:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights[
                                1:(n_curr + 1),
                                (n_curr + 1),
                            ]
                        )
                    )
                ) # Approximation of extrapolation order n_curr
                utilde = eltype(uprev).(extrapolation_scalars_2[n_curr]) *
                    sum(
                    broadcast(
                        *, T[2:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights_2[
                                1:n_curr,
                                n_curr,
                            ]
                        )
                    )
                ) # and its internal counterpart
                # FIXME this should be stored in the controller cache
                res = calculate_residuals(
                    u, utilde, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(res, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
            sum(
            broadcast(
                *, T[1:(n_curr + 1)],
                eltype(uprev).(
                    extrapolation_weights[
                        1:(n_curr + 1),
                        (n_curr + 1),
                    ]
                )
            )
        ) # Approximation of extrapolation order n_curr
    end

    # Save the latest approximation and update FSAL
    integrator.u = u
    integrator.fsallast = f(u, p, t + dt)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function initialize!(integrator, cache::ImplicitDeuflhardExtrapolationCache)
    # cf. initialize! of MidpointCache
    (; k, fsalfirst) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
end

function perform_step!(
        integrator, cache::ImplicitDeuflhardExtrapolationCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; n_curr, u_temp1, u_temp2, utilde, T, fsalfirst, k, diff1, diff2) = cache
    (; u_temp3, u_temp4, k_tmps) = cache

    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; stage_number) = cache

    (; J, W, uf, tf, linsolve_tmps, jac_config) = cache

    fill!(cache.Q, zero(eltype(cache.Q)))

    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        win_min = max(alg.min_order, n_curr - 1)
        win_max = min(alg.max_order, n_curr + 1)

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    calc_J!(J, integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = 4 * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            jacobian2W!(W[1], integrator.f.mass_matrix, dt_int, J)
            integrator.stats.nw += 1
            @.. broadcast = false u_temp2 = uprev
            @.. broadcast = false linsolve_tmps[1] = fsalfirst

            linsolve = cache.linsolve[1]

            if !repeat_step
                linres = dolinsolve(
                    integrator, linsolve; A = W[1],
                    b = _vec(linsolve_tmps[1]), linu = _vec(k)
                )
            else
                linres = dolinsolve(
                    integrator, linsolve; A = nothing,
                    b = _vec(linsolve_tmps[1]), linu = _vec(k)
                )
            end

            cache.linsolve[1] = linres.cache

            integrator.stats.nsolve += 1
            @.. broadcast = false u_temp1 = u_temp2 - k # Euler starting step
            @.. broadcast = false diff1[1] = u_temp1 - u_temp2
            for j in 2:j_int
                f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                @.. broadcast = false linsolve_tmps[1] = k - (u_temp1 - u_temp2) / dt_int

                linsolve = cache.linsolve[1]

                if !repeat_step && j == 1
                    linres = dolinsolve(
                        integrator, linsolve; A = W[1],
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                else
                    linres = dolinsolve(
                        integrator, linsolve; A = nothing,
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                end
                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false T[i + 1] = 2 * u_temp1 - u_temp2 - 2 * k # Explicit Midpoint rule
                @.. broadcast = false u_temp2 = u_temp1
                @.. broadcast = false u_temp1 = T[i + 1]
                if (i <= 1)
                    # Deuflhard Stability check for initial two sequences
                    @.. broadcast = false diff2[1] = u_temp1 - u_temp2
                    if (
                            integrator.opts.internalnorm(diff1[1], t) <
                                integrator.opts.internalnorm(0.5 * (diff2[1] - diff1[1]), t)
                        )
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int_temp = 4 * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        jacobian2W!(
                            W[Threads.threadid()], integrator.f.mass_matrix,
                            dt_int_temp, J
                        )
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false linsolve_tmps[Threads.threadid()] = fsalfirst

                        linsolve = cache.linsolve[Threads.threadid()]

                        if !repeat_step
                            linres = dolinsolve(
                                integrator, linsolve;
                                A = W[Threads.threadid()],
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        end
                        cache.linsolve[Threads.threadid()] = linres.cache

                        @.. broadcast = false k_tmps[Threads.threadid()] = -k_tmps[Threads.threadid()]
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] +
                            k_tmps[Threads.threadid()] # Euler starting step
                        @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                            u_temp4[Threads.threadid()]
                        for j in 2:j_int_temp
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false linsolve_tmps[Threads.threadid()] = k_tmps[Threads.threadid()] -
                                (
                                u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                            ) /
                                dt_int_temp

                            linsolve = cache.linsolve[Threads.threadid()]

                            if !repeat_step && j == 1
                                linres = dolinsolve(
                                    integrator, linsolve;
                                    A = W[Threads.threadid()],
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            else
                                linres = dolinsolve(
                                    integrator, linsolve; A = nothing,
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            end
                            cache.linsolve[Threads.threadid()] = linres.cache

                            @.. broadcast = false T[index + 1] = 2 *
                                u_temp3[Threads.threadid()] -
                                u_temp4[Threads.threadid()] -
                                2 * k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                @.. broadcast = false diff2[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                                @.. broadcast = false diff2[Threads.threadid()] = 0.5 *
                                    (
                                    diff2[Threads.threadid()] -
                                        diff1[Threads.threadid()]
                                )
                                if (
                                        integrator.opts.internalnorm(
                                            diff1[Threads.threadid()],
                                            t
                                        ) <
                                            integrator.opts.internalnorm(
                                            diff2[Threads.threadid()],
                                            t
                                        )
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i) #Use flag to avoid union
                    for index in indices
                        index == -1 && continue
                        j_int_temp = 4 * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        jacobian2W!(
                            W[Threads.threadid()], integrator.f.mass_matrix,
                            dt_int_temp, J
                        )
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false linsolve_tmps[Threads.threadid()] = fsalfirst

                        linsolve = cache.linsolve[Threads.threadid()]

                        if !repeat_step
                            linres = dolinsolve(
                                integrator, linsolve;
                                A = W[Threads.threadid()],
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        end
                        cache.linsolve[Threads.threadid()] = linres.cache

                        @.. broadcast = false k_tmps[Threads.threadid()] = -k_tmps[Threads.threadid()]
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] +
                            k_tmps[Threads.threadid()] # Euler starting step
                        @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                            u_temp4[Threads.threadid()]
                        for j in 2:j_int_temp
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false linsolve_tmps[Threads.threadid()] = k_tmps[Threads.threadid()] -
                                (
                                u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                            ) /
                                dt_int_temp

                            linsolve = cache.linsolve[Threads.threadid()]

                            if !repeat_step && j == 1
                                linres = dolinsolve(
                                    integrator, linsolve;
                                    A = W[Threads.threadid()],
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            else
                                linres = dolinsolve(
                                    integrator, linsolve; A = nothing,
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            end
                            cache.linsolve[Threads.threadid()] = linres.cache

                            @.. broadcast = false T[index + 1] = 2 *
                                u_temp3[Threads.threadid()] -
                                u_temp4[Threads.threadid()] -
                                2 * k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                @.. broadcast = false diff2[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                                @.. broadcast = false diff2[Threads.threadid()] = 0.5 *
                                    (
                                    diff2[Threads.threadid()] -
                                        diff1[Threads.threadid()]
                                )
                                if (
                                        integrator.opts.internalnorm(
                                            diff1[Threads.threadid()],
                                            t
                                        ) <
                                            integrator.opts.internalnorm(
                                            diff2[Threads.threadid()],
                                            t
                                        )
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        end
    end

    if integrator.force_stepfail
        return
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (alg.min_order):n_curr

            #integrator.u .= extrapolation_scalars[i+1] * sum( broadcast(*, cache.T[1:(i+1)], extrapolation_weights[1:(i+1), (i+1)]) ) # Approximation of extrapolation order i
            #cache.utilde .= extrapolation_scalars_2[i] * sum( broadcast(*, cache.T[2:(i+1)], extrapolation_weights_2[1:i, i]) ) # and its internal counterpart

            u_temp1 .= false
            u_temp2 .= false
            for j in 1:(i + 1)
                @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (i + 1)]
            end
            for j in 2:(i + 1)
                @.. broadcast = false u_temp2 += cache.T[j] * extrapolation_weights_2[j - 1, i]
            end
            @.. broadcast = false integrator.u = extrapolation_scalars[i + 1] * u_temp1
            @.. broadcast = false cache.utilde = extrapolation_scalars_2[i] * u_temp2

            calculate_residuals!(
                cache.atmp, integrator.u, cache.utilde,
                integrator.opts.abstol, integrator.opts.reltol,
                integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        while n_curr <= win_max
            tol = integrator.opts.internalnorm(cache.utilde - integrator.u, t) /
                integrator.EEst # Used by the convergence monitor
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif integrator.EEst <=
                    tol^(
                    stage_number[n_curr - alg.min_order + 1] /
                        stage_number[win_max - alg.min_order + 1] - 1
                )
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update cache.T
                j_int = 4 * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                jacobian2W!(W[1], integrator.f.mass_matrix, dt_int, J)
                integrator.stats.nw += 1
                @.. broadcast = false u_temp2 = uprev
                @.. broadcast = false linsolve_tmps[1] = fsalfirst

                linsolve = cache.linsolve[1]
                linres = dolinsolve(
                    integrator, linsolve; b = _vec(linsolve_tmps[1]),
                    linu = _vec(k)
                )
                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false u_temp1 = u_temp2 - k # Euler starting step
                for j in 2:j_int
                    f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    @.. broadcast = false linsolve_tmps[1] = dt_int * k - (u_temp1 - u_temp2)

                    linsolve = cache.linsolve[1]
                    linres = dolinsolve(
                        integrator, linsolve; b = _vec(linsolve_tmps[1]),
                        linu = _vec(k)
                    )
                    cache.linsolve[1] = linres.cache

                    integrator.stats.nsolve += 1
                    @.. broadcast = false T[n_curr + 1] = 2 * u_temp1 - u_temp2 - 2 * k # Explicit Midpoint rule
                    @.. broadcast = false u_temp2 = u_temp1
                    @.. broadcast = false u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
                #cache.utilde .= extrapolation_scalars_2[n_curr] * sum( broadcast(*, cache.T[2:(n_curr+1)], extrapolation_weights_2[1:n_curr, n_curr]) ) # and its internal counterpart

                u_temp1 .= false
                u_temp2 .= false
                for j in 1:(n_curr + 1)
                    @.. broadcast = false u_temp1 += cache.T[j] *
                        extrapolation_weights[j, (n_curr + 1)]
                end
                for j in 2:(n_curr + 1)
                    @.. broadcast = false u_temp2 += cache.T[j] *
                        extrapolation_weights_2[j - 1, n_curr]
                end
                @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
                @.. broadcast = false cache.utilde = extrapolation_scalars_2[n_curr] * u_temp2

                calculate_residuals!(
                    cache.atmp, integrator.u, cache.utilde,
                    integrator.opts.abstol, integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else

        #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
        u_temp1 .= false
        for j in 1:(n_curr + 1)
            @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (n_curr + 1)]
        end
        @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
    end

    f(cache.k, integrator.u, p, t + dt) # Update FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ImplicitDeuflhardExtrapolationConstantCache)
    # cf. initialize! of MidpointConstantCache
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function perform_step!(
        integrator, cache::ImplicitDeuflhardExtrapolationConstantCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; n_curr) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; stage_number) = cache

    # Create auxiliary variables
    u_temp1, u_temp2 = copy(uprev), copy(uprev) # Auxiliary variables for computing the internal discretisations
    u, utilde = copy(uprev), copy(uprev) # Storage for the latest approximation and its internal counterpart
    T = fill(zero(uprev), alg.max_order + 1) # Storage for the internal discretisations obtained by the explicit midpoint rule
    fill!(cache.Q, zero(eltype(cache.Q)))

    # Start computation
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        win_min = max(alg.min_order, n_curr - 1)
        win_max = min(alg.max_order, n_curr + 1)

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    # Compute the internal discretisations
    J = calc_J(integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = 4 * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            W = dt_int * J - integrator.f.mass_matrix
            integrator.stats.nw += 1
            u_temp2 = uprev
            u_temp1 = u_temp2 +
                _reshape(W \ -_vec(dt_int * integrator.fsalfirst), axes(uprev)) # Euler starting step
            diff1 = u_temp1 - u_temp2
            for j in 2:j_int
                T[i + 1] = 2 * u_temp1 - u_temp2 +
                    2 * _reshape(
                    W \
                        -_vec(
                        dt_int * f(u_temp1, p, t + (j - 1) * dt_int) -
                            (u_temp1 - u_temp2)
                    ),
                    axes(uprev)
                )
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                u_temp2 = u_temp1
                u_temp1 = T[i + 1]
                if (i <= 1)
                    # Deuflhard Stability check for initial two sequences
                    diff2 = u_temp1 - u_temp2
                    if (
                            integrator.opts.internalnorm(diff1, t) <
                                integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                        )
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp2 = u_temp2, u_temp2 = u_temp2, p = p, t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int = 4 * subdividing_sequence[index + 1]
                        dt_int = dt / j_int # Stepsize of the ith internal discretisation
                        W = dt_int * J - integrator.f.mass_matrix
                        integrator.stats.nw += 1
                        u_temp4 = uprev
                        u_temp3 = u_temp4 +
                            _reshape(
                            W \ -_vec(dt_int * integrator.fsalfirst),
                            axes(uprev)
                        ) # Euler starting step
                        diff1 = u_temp3 - u_temp4
                        for j in 2:j_int
                            T[index + 1] = 2 * u_temp3 - u_temp4 +
                                2 * _reshape(
                                W \
                                    -_vec(
                                    dt_int * f(
                                        u_temp3, p,
                                        t + (j - 1) * dt_int
                                    ) -
                                        (u_temp3 - u_temp4)
                                ),
                                axes(uprev)
                            )
                            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                diff2 = u_temp3 - u_temp4
                                if (
                                        integrator.opts.internalnorm(diff1[1], t) <
                                            integrator.opts.internalnorm(
                                            0.5 *
                                                (diff2[1] - diff1[1]), t
                                        )
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, integrator = integrator, p = p, t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i)
                    for index in indices
                        index == -1 && continue
                        j_int = 4 * subdividing_sequence[index + 1]
                        dt_int = dt / j_int # Stepsize of the ith internal discretisation
                        W = dt_int * J - integrator.f.mass_matrix
                        integrator.stats.nw += 1
                        u_temp4 = uprev
                        u_temp3 = u_temp4 +
                            _reshape(
                            W \ -_vec(dt_int * integrator.fsalfirst),
                            axes(uprev)
                        ) # Euler starting step
                        diff1 = u_temp3 - u_temp4
                        for j in 2:j_int
                            T[index + 1] = 2 * u_temp3 - u_temp4 +
                                2 * _reshape(
                                W \
                                    -_vec(
                                    dt_int * f(
                                        u_temp3, p,
                                        t + (j - 1) * dt_int
                                    ) -
                                        (u_temp3 - u_temp4)
                                ),
                                axes(uprev)
                            )
                            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                diff2 = u_temp3 - u_temp4
                                if (
                                        integrator.opts.internalnorm(diff1, t) <
                                            integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        end
    end

    if integrator.force_stepfail
        return
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (alg.min_order):n_curr
            u = eltype(uprev).(extrapolation_scalars[i + 1]) *
                sum(
                broadcast(
                    *, T[1:(i + 1)],
                    eltype(uprev).(extrapolation_weights[1:(i + 1), (i + 1)])
                )
            ) # Approximation of extrapolation order i
            utilde = eltype(uprev).(extrapolation_scalars_2[i]) *
                sum(
                broadcast(
                    *, T[2:(i + 1)],
                    eltype(uprev).(extrapolation_weights_2[1:i, i])
                )
            ) # and its internal counterpart
            # FIXME this should be stored in the controller cache
            res = calculate_residuals(
                u, utilde, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(res, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        while n_curr <= win_max
            tol = integrator.opts.internalnorm(utilde - u, t) / integrator.EEst # Used by the convergence monitor
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif integrator.EEst <=
                    tol^(
                    stage_number[n_curr - alg.min_order + 1] /
                        stage_number[win_max - alg.min_order + 1] - 1
                )
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update T
                j_int = 4 * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                W = dt_int * J - integrator.f.mass_matrix
                integrator.stats.nw += 1
                u_temp2 = uprev
                u_temp1 = u_temp2 +
                    _reshape(W \ -_vec(dt_int * integrator.fsalfirst), axes(uprev)) # Euler starting step
                for j in 2:j_int
                    T[n_curr + 1] = 2 * u_temp1 - u_temp2 +
                        2 * _reshape(
                        W \
                            -_vec(
                            dt_int *
                                f(u_temp1, p, t + (j - 1) * dt_int) -
                                (u_temp1 - u_temp2)
                        ),
                        axes(uprev)
                    )
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    u_temp2 = u_temp1
                    u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
                    sum(
                    broadcast(
                        *, T[1:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights[
                                1:(n_curr + 1),
                                (n_curr + 1),
                            ]
                        )
                    )
                ) # Approximation of extrapolation order n_curr
                utilde = eltype(uprev).(extrapolation_scalars_2[n_curr]) *
                    sum(
                    broadcast(
                        *, T[2:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights_2[
                                1:n_curr,
                                n_curr,
                            ]
                        )
                    )
                ) # and its internal counterpart
                # FIXME this should be stored in the controller cache
                res = calculate_residuals(
                    u, utilde, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(res, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
            sum(
            broadcast(
                *, T[1:(n_curr + 1)],
                eltype(uprev).(
                    extrapolation_weights[
                        1:(n_curr + 1),
                        (n_curr + 1),
                    ]
                )
            )
        ) # Approximation of extrapolation order n_curr
    end

    # Save the latest approximation and update FSAL
    integrator.u = u
    integrator.fsallast = f(u, p, t + dt)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ExtrapolationMidpointHairerWannerCache)
    # cf. initialize! of MidpointCache
    (; k, fsalfirst) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
end

function perform_step!(
        integrator, cache::ExtrapolationMidpointHairerWannerCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; n_curr, u_temp1, u_temp2, utilde, T, fsalfirst, k) = cache
    (; u_temp3, u_temp4, k_tmps) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; sequence_factor) = alg

    fill!(cache.Q, zero(eltype(cache.Q)))

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = sequence_factor * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            @.. broadcast = false u_temp2 = uprev
            @.. broadcast = false u_temp1 = u_temp2 + dt_int * fsalfirst # Euler starting step
            for j in 2:j_int
                f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                @.. broadcast = false T[i + 1] = u_temp2 + 2 * dt_int * k # Explicit Midpoint rule
                @.. broadcast = false u_temp2 = u_temp1
                @.. broadcast = false u_temp1 = T[i + 1]
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] +
                            dt_int_temp *
                            fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false T[index + 1] = u_temp4[Threads.threadid()] +
                                2 * dt_int_temp *
                                k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                        end
                    end
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i)
                    for index in indices
                        index == -1 && continue
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] +
                            dt_int_temp *
                            fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false T[index + 1] = u_temp4[Threads.threadid()] +
                                2 * dt_int_temp *
                                k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                        end
                    end
                end
            end
        end
        nevals = cache.stage_number[n_curr + 1] - 1
        integrator.stats.nf += nevals
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min

            #integrator.u .= extrapolation_scalars[i+1] * sum( broadcast(*, cache.T[1:(i+1)], extrapolation_weights[1:(i+1), (i+1)]) ) # Approximation of extrapolation order i
            #cache.utilde .= extrapolation_scalars_2[i] * sum( broadcast(*, cache.T[2:(i+1)], extrapolation_weights_2[1:i, i]) ) # and its internal counterpart

            u_temp1 .= false
            u_temp2 .= false
            for j in 1:(i + 1)
                @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (i + 1)]
            end
            for j in 2:(i + 1)
                @.. broadcast = false u_temp2 += cache.T[j] * extrapolation_weights_2[j - 1, i]
            end
            @.. broadcast = false integrator.u = extrapolation_scalars[i + 1] * u_temp1
            @.. broadcast = false cache.utilde = extrapolation_scalars_2[i] * u_temp2

            calculate_residuals!(
                cache.atmp, integrator.u, cache.utilde,
                integrator.opts.abstol, integrator.opts.reltol,
                integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) ||
                    integrator.EEst <=
                    typeof(integrator.EEst)(
                    prod(
                        subdividing_sequence[(n_curr + 2):(win_max + 1)] .//
                            subdividing_sequence[1]^2
                    )
                )
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update cache.T
                j_int = sequence_factor * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                @.. broadcast = false u_temp2 = uprev
                @.. broadcast = false u_temp1 = u_temp2 + dt_int * fsalfirst # Euler starting step
                for j in 2:j_int
                    f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    @.. broadcast = false T[n_curr + 1] = u_temp2 + 2 * dt_int * k
                    @.. broadcast = false u_temp2 = u_temp1
                    @.. broadcast = false u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
                #cache.utilde .= extrapolation_scalars_2[n_curr] * sum( broadcast(*, cache.T[2:(n_curr+1)], extrapolation_weights_2[1:n_curr, n_curr]) ) # and its internal counterpart

                u_temp1 .= false
                u_temp2 .= false
                for j in 1:(n_curr + 1)
                    @.. broadcast = false u_temp1 += cache.T[j] *
                        extrapolation_weights[j, (n_curr + 1)]
                end
                for j in 2:(n_curr + 1)
                    @.. broadcast = false u_temp2 += cache.T[j] *
                        extrapolation_weights_2[j - 1, n_curr]
                end
                @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
                @.. broadcast = false cache.utilde = extrapolation_scalars_2[n_curr] * u_temp2

                calculate_residuals!(
                    cache.atmp, integrator.u, cache.utilde,
                    integrator.opts.abstol, integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else

        #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
        u_temp1 .= false
        for j in 1:(n_curr + 1)
            @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (n_curr + 1)]
        end
        @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
    end

    f(cache.k, integrator.u, p, t + dt) # Update FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ExtrapolationMidpointHairerWannerConstantCache)
    # cf. initialize! of MidpointConstantCache
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function perform_step!(
        integrator, cache::ExtrapolationMidpointHairerWannerConstantCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; n_curr) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; sequence_factor) = alg

    # Create auxiliary variables
    u_temp1, u_temp2 = copy(uprev), copy(uprev) # Auxiliary variables for computing the internal discretisations
    u, utilde = copy(uprev), copy(uprev) # Storage for the latest approximation and its internal counterpart
    T = fill(zero(uprev), alg.max_order + 1) # Storage for the internal discretisations obtained by the explicit midpoint rule
    fill!(cache.Q, zero(eltype(cache.Q)))

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = sequence_factor * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            u_temp2 = uprev
            u_temp1 = u_temp2 + dt_int * integrator.fsalfirst # Euler starting step
            for j in 2:j_int
                T[i + 1] = u_temp2 + 2 * dt_int * f(u_temp1, p, t + (j - 1) * dt_int) # Explicit Midpoint rule
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                u_temp2 = u_temp1
                u_temp1 = T[i + 1]
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, dt = dt,
                    uprev = uprev, integrator = integrator, T = T, p = p, t = t

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr
                    for index in startIndex:endIndex
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        u_temp4 = uprev
                        u_temp3 = u_temp4 + dt_int_temp * integrator.fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            T[index + 1] = u_temp4 +
                                2 * dt_int_temp *
                                f(u_temp3, p, t + (j - 1) * dt_int_temp) # Explicit Midpoint rule
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                        end
                    end
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, dt = dt,
                    uprev = uprev, integrator = integrator, T = T, p = p, t = t

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i)
                    for index in indices
                        index == -1 && continue
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        u_temp4 = uprev
                        u_temp3 = u_temp4 + dt_int_temp * integrator.fsalfirst # Euler starting step
                        for j in 2:j_int_temp
                            T[index + 1] = u_temp4 +
                                2 * dt_int_temp *
                                f(u_temp3, p, t + (j - 1) * dt_int_temp) # Explicit Midpoint rule
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                        end
                    end
                end
            end
        end
        nevals = cache.stage_number[n_curr + 1] - 1
        integrator.stats.nf += nevals
    end
    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min
            u = eltype(uprev).(extrapolation_scalars[i + 1]) *
                sum(
                broadcast(
                    *, T[1:(i + 1)],
                    eltype(uprev).(extrapolation_weights[1:(i + 1), (i + 1)])
                )
            ) # Approximation of extrapolation order i
            utilde = eltype(uprev).(extrapolation_scalars_2[i]) *
                sum(
                broadcast(
                    *, T[2:(i + 1)],
                    eltype(uprev).(extrapolation_weights_2[1:i, i])
                )
            ) # and its internal counterpart
            # FIXME this should be stored in the controller cache
            res = calculate_residuals(
                u, utilde, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(res, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) ||
                    integrator.EEst <=
                    typeof(integrator.EEst)(
                    prod(
                        subdividing_sequence[(n_curr + 2):(win_max + 1)] .//
                            subdividing_sequence[1]^2
                    )
                )
                # Reject current approximation order but pass convergence monitor
                # Always compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update T
                j_int = sequence_factor * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                u_temp2 = uprev
                u_temp1 = u_temp2 + dt_int * integrator.fsalfirst # Euler starting step
                for j in 2:j_int
                    T[n_curr + 1] = u_temp2 +
                        2 * dt_int * f(u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    u_temp2 = u_temp1
                    u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
                    sum(
                    broadcast(
                        *, T[1:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights[
                                1:(n_curr + 1),
                                (n_curr + 1),
                            ]
                        )
                    )
                ) # Approximation of extrapolation order n_curr
                utilde = eltype(uprev).(extrapolation_scalars_2[n_curr]) *
                    sum(
                    broadcast(
                        *, T[2:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights_2[
                                1:n_curr,
                                n_curr,
                            ]
                        )
                    )
                ) # and its internal counterpart
                # FIXME this should be stored in the controller cache
                res = calculate_residuals(
                    u, utilde, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(res, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
            sum(
            broadcast(
                *, T[1:(n_curr + 1)],
                eltype(uprev).(
                    extrapolation_weights[
                        1:(n_curr + 1),
                        (n_curr + 1),
                    ]
                )
            )
        ) # Approximation of extrapolation order n_curr
    end

    # Save the latest approximation and update FSAL
    integrator.u = u
    integrator.fsallast = f(u, p, t + dt)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ImplicitHairerWannerExtrapolationConstantCache)
    # cf. initialize! of MidpointConstantCache
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function perform_step!(
        integrator, cache::ImplicitHairerWannerExtrapolationConstantCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; n_curr) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients

    # Create auxiliary variables
    u_temp1, u_temp2 = copy(uprev), copy(uprev) # Auxiliary variables for computing the internal discretisations
    u, utilde = copy(uprev), copy(uprev) # Storage for the latest approximation and its internal counterpart
    T = fill(zero(uprev), alg.max_order + 1) # Storage for the internal discretisations obtained by the explicit midpoint rule
    fill!(cache.Q, zero(eltype(cache.Q)))

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    J = calc_J(integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = 4 * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            W = dt_int * J - integrator.f.mass_matrix
            integrator.stats.nw += 1
            u_temp2 = uprev
            u_temp1 = u_temp2 +
                _reshape(W \ -_vec(dt_int * integrator.fsalfirst), axes(uprev)) # Euler starting step
            diff1 = u_temp1 - u_temp2
            for j in 2:(j_int + 1)
                T[i + 1] = 2 * u_temp1 - u_temp2 +
                    2 * _reshape(
                    W \
                        -_vec(
                        dt_int * f(u_temp1, p, t + (j - 1) * dt_int) -
                            (u_temp1 - u_temp2)
                    ),
                    axes(uprev)
                )
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                if (j == j_int + 1)
                    T[i + 1] = 0.5(T[i + 1] + u_temp2)
                end
                u_temp2 = u_temp1
                u_temp1 = T[i + 1]
                if (i <= 1)
                    # Deuflhard Stability check for initial two sequences
                    diff2 = u_temp1 - u_temp2
                    if (
                            integrator.opts.internalnorm(diff1, t) <
                                integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                        )
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
                diff1 = u_temp1 - u_temp2
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp2 = u_temp2, u_temp2 = u_temp2, p = p, t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int = 4 * subdividing_sequence[index + 1]
                        dt_int = dt / j_int # Stepsize of the ith internal discretisation
                        W = dt_int * J - integrator.f.mass_matrix
                        integrator.stats.nw += 1
                        u_temp4 = uprev
                        u_temp3 = u_temp4 +
                            _reshape(
                            W \ -_vec(dt_int * integrator.fsalfirst),
                            axes(uprev)
                        ) # Euler starting step
                        diff1 = u_temp3 - u_temp4
                        for j in 2:(j_int + 1)
                            T[index + 1] = 2 * u_temp3 - u_temp4 +
                                2 * _reshape(
                                W \
                                    -_vec(
                                    dt_int * f(
                                        u_temp3, p,
                                        t + (j - 1) * dt_int
                                    ) -
                                        (u_temp3 - u_temp4)
                                ),
                                axes(uprev)
                            )
                            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                            if (j == j_int + 1)
                                T[index + 1] = 0.5(T[index + 1] + u_temp4)
                            end
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                diff2 = u_temp3 - u_temp4
                                if (
                                        integrator.opts.internalnorm(diff1, t) <
                                            integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            diff1 = u_temp3 - u_temp4
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, integrator = integrator, p = p, t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i)
                    for index in indices
                        index == -1 && continue
                        j_int = 4 * subdividing_sequence[index + 1]
                        dt_int = dt / j_int # Stepsize of the ith internal discretisation
                        W = dt_int * J - integrator.f.mass_matrix
                        integrator.stats.nw += 1
                        u_temp4 = uprev
                        u_temp3 = u_temp4 +
                            _reshape(
                            W \ -_vec(dt_int * integrator.fsalfirst),
                            axes(uprev)
                        ) # Euler starting step
                        diff1 = u_temp3 - u_temp4
                        for j in 2:(j_int + 1)
                            T[index + 1] = 2 * u_temp3 - u_temp4 +
                                2 * _reshape(
                                W \
                                    -_vec(
                                    dt_int * f(
                                        u_temp3, p,
                                        t + (j - 1) * dt_int
                                    ) -
                                        (u_temp3 - u_temp4)
                                ),
                                axes(uprev)
                            )
                            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                            if (j == j_int + 1)
                                T[index + 1] = 0.5(T[index + 1] + u_temp4)
                            end
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                diff2 = u_temp3 - u_temp4
                                if (
                                        integrator.opts.internalnorm(diff1, t) <
                                            integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            diff1 = u_temp3 - u_temp4
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        end
    end

    if integrator.force_stepfail
        return
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min
            u = eltype(uprev).(extrapolation_scalars[i + 1]) *
                sum(
                broadcast(
                    *, T[1:(i + 1)],
                    eltype(uprev).(extrapolation_weights[1:(i + 1), (i + 1)])
                )
            ) # Approximation of extrapolation order i
            utilde = eltype(uprev).(extrapolation_scalars_2[i]) *
                sum(
                broadcast(
                    *, T[2:(i + 1)],
                    eltype(uprev).(extrapolation_weights_2[1:i, i])
                )
            ) # and its internal counterpart
            # FIXME this should be stored in the controller cache
            res = calculate_residuals(
                u, utilde, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(res, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) ||
                    integrator.EEst <=
                    typeof(integrator.EEst)(
                    prod(
                        subdividing_sequence[(n_curr + 2):(win_max + 1)] .//
                            subdividing_sequence[1]^2
                    )
                )
                # Reject current approximation order but pass convergence monitor
                # Always compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update T
                j_int = 4 * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                W = dt_int * J - integrator.f.mass_matrix
                integrator.stats.nw += 1
                u_temp2 = uprev
                u_temp1 = u_temp2 +
                    _reshape(W \ -_vec(dt_int * integrator.fsalfirst), axes(uprev)) # Euler starting step
                for j in 2:(j_int + 1)
                    T[n_curr + 1] = 2 * u_temp1 - u_temp2 +
                        2 * _reshape(
                        W \
                            -_vec(
                            dt_int *
                                f(u_temp1, p, t + (j - 1) * dt_int) -
                                (u_temp1 - u_temp2)
                        ),
                        axes(uprev)
                    )
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    if (j == j_int + 1)
                        T[n_curr + 1] = 0.5(T[n_curr + 1] + u_temp2)
                    end
                    u_temp2 = u_temp1
                    u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
                    sum(
                    broadcast(
                        *, T[1:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights[
                                1:(n_curr + 1),
                                (n_curr + 1),
                            ]
                        )
                    )
                ) # Approximation of extrapolation order n_curr
                utilde = eltype(uprev).(extrapolation_scalars_2[n_curr]) *
                    sum(
                    broadcast(
                        *, T[2:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights_2[
                                1:n_curr,
                                n_curr,
                            ]
                        )
                    )
                ) # and its internal counterpart
                # FIXME this should be stored in the controller cache
                res = calculate_residuals(
                    u, utilde, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(res, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
            sum(
            broadcast(
                *, T[1:(n_curr + 1)],
                eltype(uprev).(
                    extrapolation_weights[
                        1:(n_curr + 1),
                        (n_curr + 1),
                    ]
                )
            )
        ) # Approximation of extrapolation order n_curr
    end

    # Save the latest approximation and update FSAL
    integrator.u = u
    integrator.fsallast = f(u, p, t + dt)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function initialize!(integrator, cache::ImplicitHairerWannerExtrapolationCache)
    # cf. initialize! of MidpointCache
    (; k, fsalfirst) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
end

function perform_step!(
        integrator, cache::ImplicitHairerWannerExtrapolationCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; n_curr, u_temp1, u_temp2, utilde, T, fsalfirst, k, diff1, diff2) = cache
    (; u_temp3, u_temp4, k_tmps) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients

    (; J, W, uf, tf, linsolve_tmps, jac_config) = cache

    fill!(cache.Q, zero(eltype(cache.Q)))

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    calc_J!(J, integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = 4 * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            jacobian2W!(W[1], integrator.f.mass_matrix, dt_int, J)
            integrator.stats.nw += 1
            @.. broadcast = false u_temp2 = uprev
            @.. broadcast = false linsolve_tmps[1] = fsalfirst

            linsolve = cache.linsolve[1]
            if !repeat_step
                linres = dolinsolve(
                    integrator, linsolve; A = W[1],
                    b = _vec(linsolve_tmps[1]), linu = _vec(k)
                )
            else
                linres = dolinsolve(
                    integrator, linsolve; A = nothing,
                    b = _vec(linsolve_tmps[1]), linu = _vec(k)
                )
            end
            cache.linsolve[1] = linres.cache

            integrator.stats.nsolve += 1
            @.. broadcast = false u_temp1 = u_temp2 - k # Euler starting step
            @.. broadcast = false diff1[1] = u_temp1 - u_temp2
            for j in 2:(j_int + 1)
                f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                @.. broadcast = false linsolve_tmps[1] = k - (u_temp1 - u_temp2) / dt_int

                linsolve = cache.linsolve[1]

                if !repeat_step && j == 1
                    linres = dolinsolve(
                        integrator, linsolve; A = W[1],
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                else
                    linres = dolinsolve(
                        integrator, linsolve; A = nothing,
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                end
                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false T[i + 1] = 2 * u_temp1 - u_temp2 - 2 * k # Explicit Midpoint rule
                if (j == j_int + 1)
                    @.. broadcast = false T[i + 1] = 0.5(T[i + 1] + u_temp2)
                end
                @.. broadcast = false u_temp2 = u_temp1
                @.. broadcast = false u_temp1 = T[i + 1]
                if (i <= 1)
                    # Deuflhard Stability check for initial two sequences
                    @.. broadcast = false diff2[1] = u_temp1 - u_temp2
                    @.. broadcast = false diff2[1] = 0.5 * (diff2[1] - diff1[1])
                    if (
                            integrator.opts.internalnorm(diff1[1], t) <
                                integrator.opts.internalnorm(diff2[1], t)
                        )
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
                @.. broadcast = false diff1[1] = u_temp1 - u_temp2
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int_temp = 4 * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        jacobian2W!(
                            W[Threads.threadid()], integrator.f.mass_matrix,
                            dt_int_temp, J
                        )
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false linsolve_tmps[Threads.threadid()] = fsalfirst

                        linsolve = cache.linsolve[Threads.threadid()]

                        if !repeat_step
                            linres = dolinsolve(
                                integrator, linsolve;
                                A = W[Threads.threadid()],
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        end
                        cache.linsolve[Threads.threadid()] = linres.cache

                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] -
                            k_tmps[Threads.threadid()] # Euler starting step
                        @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                            u_temp4[Threads.threadid()]
                        for j in 2:(j_int_temp + 1)
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false linsolve_tmps[Threads.threadid()] = k_tmps[Threads.threadid()] -
                                (
                                u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                            ) /
                                dt_int_temp

                            linsolve = cache.linsolve[Threads.threadid()]
                            if !repeat_step && j == 1
                                linres = dolinsolve(
                                    integrator, linsolve;
                                    A = W[Threads.threadid()],
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            else
                                linres = dolinsolve(
                                    integrator, linsolve; A = nothing,
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            end
                            cache.linsolve[Threads.threadid()] = linres.cache

                            @.. broadcast = false T[index + 1] = 2 *
                                u_temp3[Threads.threadid()] -
                                u_temp4[Threads.threadid()] -
                                2 * k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            if (j == j_int_temp + 1)
                                @.. broadcast = false T[index + 1] = 0.5(
                                    T[index + 1] +
                                        u_temp4[Threads.threadid()]
                                )
                            end
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                @.. broadcast = false diff2[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                                @.. broadcast = false diff2[Threads.threadid()] = 0.5 *
                                    (
                                    diff2[Threads.threadid()] -
                                        diff1[Threads.threadid()]
                                )
                                if (
                                        integrator.opts.internalnorm(
                                            diff1[Threads.threadid()],
                                            t
                                        ) <
                                            integrator.opts.internalnorm(
                                            diff2[Threads.threadid()],
                                            t
                                        )
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                u_temp4[Threads.threadid()]
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    tid = Threads.threadid()
                    linsolvetmp = linsolve_tmps[tid]
                    ktmp = k_tmps[tid]
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i) #Use flag to avoid type union/branch
                    for index in indices
                        index == -1 && continue
                        j_int_temp = 4 * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        jacobian2W!(W[tid], integrator.f.mass_matrix, dt_int_temp, J)
                        @.. broadcast = false u_temp4[tid] = uprev
                        @.. broadcast = false linsolvetmp = fsalfirst

                        linsolve = cache.linsolve[tid]
                        if !repeat_step
                            linres = dolinsolve(
                                integrator, linsolve; A = W[tid],
                                b = _vec(linsolvetmp), linu = _vec(ktmp)
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolvetmp), linu = _vec(ktmp)
                            )
                        end
                        cache.linsolve[tid] = linres.cache

                        @.. broadcast = false u_temp3[tid] = u_temp4[tid] - ktmp # Euler starting step
                        @.. broadcast = false diff1[tid] = u_temp3[tid] - u_temp4[tid]
                        for j in 2:(j_int_temp + 1)
                            f(ktmp, cache.u_temp3[tid], p, t + (j - 1) * dt_int_temp)
                            @.. broadcast = false linsolvetmp = ktmp -
                                (u_temp3[tid] - u_temp4[tid]) /
                                dt_int_temp

                            linsolve = cache.linsolve[tid]

                            if (!repeat_step && j == 1)
                                linres = dolinsolve(
                                    integrator, linsolve; A = W[tid],
                                    b = _vec(linsolvetmp),
                                    linu = _vec(ktmp)
                                )
                            else
                                linres = dolinsolve(
                                    integrator, linsolve; A = nothing,
                                    b = _vec(linsolvetmp),
                                    linu = _vec(ktmp)
                                )
                            end
                            cache.linsolve[tid] = linres.cache

                            @.. broadcast = false T[index + 1] = 2 * u_temp3[tid] -
                                u_temp4[tid] - 2 * ktmp # Explicit Midpoint rule
                            if (j == j_int_temp + 1)
                                @.. broadcast = false T[index + 1] = 0.5(
                                    T[index + 1] +
                                        u_temp4[tid]
                                )
                            end
                            @.. broadcast = false u_temp4[tid] = u_temp3[tid]
                            @.. broadcast = false u_temp3[tid] = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                @.. broadcast = false diff2[tid] = u_temp3[tid] - u_temp4[tid]
                                @.. broadcast = false diff2[tid] = 0.5 *
                                    (diff2[tid] - diff1[tid])
                                if (
                                        integrator.opts.internalnorm(diff1[tid], t) <
                                            integrator.opts.internalnorm(diff2[tid], t)
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            @.. broadcast = false diff1[tid] = u_temp3[tid] - u_temp4[tid]
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        end
    end

    if integrator.force_stepfail
        return
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min

            #integrator.u .= extrapolation_scalars[i+1] * sum( broadcast(*, cache.T[1:(i+1)], extrapolation_weights[1:(i+1), (i+1)]) ) # Approximation of extrapolation order i
            #cache.utilde .= extrapolation_scalars_2[i] * sum( broadcast(*, cache.T[2:(i+1)], extrapolation_weights_2[1:i, i]) ) # and its internal counterpart

            u_temp1 .= false
            u_temp2 .= false
            for j in 1:(i + 1)
                @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (i + 1)]
            end
            for j in 2:(i + 1)
                @.. broadcast = false u_temp2 += cache.T[j] * extrapolation_weights_2[j - 1, i]
            end
            @.. broadcast = false integrator.u = extrapolation_scalars[i + 1] * u_temp1
            @.. broadcast = false cache.utilde = extrapolation_scalars_2[i] * u_temp2

            calculate_residuals!(
                cache.atmp, integrator.u, cache.utilde,
                integrator.opts.abstol, integrator.opts.reltol,
                integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            EEst1 = one(integrator.EEst)
            for i in (n_curr + 2):(win_max + 1)
                EEst1 *= subdividing_sequence[i] / subdividing_sequence[1]
            end
            EEst1 *= EEst1
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) || integrator.EEst <= EEst1
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update cache.T
                j_int = 4 * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                jacobian2W!(W[1], integrator.f.mass_matrix, dt_int, J)
                integrator.stats.nw += 1
                @.. broadcast = false u_temp2 = uprev
                @.. broadcast = false linsolve_tmps[1] = fsalfirst

                linsolve = cache.linsolve[1]

                if !repeat_step
                    linres = dolinsolve(
                        integrator, linsolve; A = W[1],
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                else
                    linres = dolinsolve(
                        integrator, linsolve; A = nothing,
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                end
                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false u_temp1 = u_temp2 - k # Euler starting step
                for j in 2:(j_int + 1)
                    f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    @.. broadcast = false linsolve_tmps[1] = k - (u_temp1 - u_temp2) / dt_int

                    linsolve = cache.linsolve[1]

                    if !repeat_step && j == 1
                        linres = dolinsolve(
                            integrator, linsolve; A = W[1],
                            b = _vec(linsolve_tmps[1]), linu = _vec(k)
                        )
                    else
                        linres = dolinsolve(
                            integrator, linsolve; A = nothing,
                            b = _vec(linsolve_tmps[1]), linu = _vec(k)
                        )
                    end
                    cache.linsolve[1] = linres.cache

                    integrator.stats.nsolve += 1
                    @.. broadcast = false T[n_curr + 1] = 2 * u_temp1 - u_temp2 - 2 * k # Explicit Midpoint rule
                    if (j == j_int + 1)
                        @.. broadcast = false T[n_curr + 1] = 0.5(T[n_curr + 1] + u_temp2)
                    end
                    @.. broadcast = false u_temp2 = u_temp1
                    @.. broadcast = false u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
                #cache.utilde .= extrapolation_scalars_2[n_curr] * sum( broadcast(*, cache.T[2:(n_curr+1)], extrapolation_weights_2[1:n_curr, n_curr]) ) # and its internal counterpart

                u_temp1 .= false
                u_temp2 .= false
                for j in 1:(n_curr + 1)
                    @.. broadcast = false u_temp1 += cache.T[j] *
                        extrapolation_weights[j, (n_curr + 1)]
                end
                for j in 2:(n_curr + 1)
                    @.. broadcast = false u_temp2 += cache.T[j] *
                        extrapolation_weights_2[j - 1, n_curr]
                end
                @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
                @.. broadcast = false cache.utilde = extrapolation_scalars_2[n_curr] * u_temp2

                calculate_residuals!(
                    cache.atmp, integrator.u, cache.utilde,
                    integrator.opts.abstol, integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else

        #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
        u_temp1 .= false
        for j in 1:(n_curr + 1)
            @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (n_curr + 1)]
        end
        @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
    end

    f(cache.k, integrator.u, p, t + dt) # Update FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::ImplicitEulerBarycentricExtrapolationConstantCache)
    # cf. initialize! of MidpointConstantCache
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function perform_step!(
        integrator,
        cache::ImplicitEulerBarycentricExtrapolationConstantCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; n_curr) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; sequence_factor) = alg

    # Create auxiliary variables
    u_temp1, u_temp2 = copy(uprev), copy(uprev) # Auxiliary variables for computing the internal discretisations
    u, utilde = copy(uprev), copy(uprev) # Storage for the latest approximation and its internal counterpart
    T = fill(zero(uprev), alg.max_order + 1) # Storage for the internal discretisations obtained by the explicit midpoint rule
    fill!(cache.Q, zero(eltype(cache.Q)))

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    J = calc_J(integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = sequence_factor * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            W = dt_int * J - integrator.f.mass_matrix
            integrator.stats.nw += 1
            u_temp2 = uprev
            u_temp1 = u_temp2 +
                _reshape(W \ -_vec(dt_int * integrator.fsalfirst), axes(uprev)) # Euler starting step
            diff1 = u_temp1 - u_temp2
            for j in 2:(j_int + 1)
                T[i + 1] = u_temp1 +
                    _reshape(
                    W \ -_vec(dt_int * f(u_temp1, p, t + (j - 1) * dt_int)),
                    axes(uprev)
                )
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                if (j == j_int + 1)
                    T[i + 1] = 0.25(T[i + 1] + 2 * u_temp1 + u_temp2)
                end
                u_temp2 = u_temp1
                u_temp1 = T[i + 1]
                if (i <= 1)
                    # Deuflhard Stability check for initial two sequences
                    diff2 = u_temp1 - u_temp2
                    if (
                            integrator.opts.internalnorm(diff1, t) <
                                integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                        )
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
                diff1 = u_temp1 - u_temp2
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp2 = u_temp2, u_temp2 = u_temp2, p = p, t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int = sequence_factor * subdividing_sequence[index + 1]
                        dt_int = dt / j_int # Stepsize of the ith internal discretisation
                        W = dt_int * J - integrator.f.mass_matrix
                        integrator.stats.nw += 1
                        u_temp4 = uprev
                        u_temp3 = u_temp4 +
                            _reshape(
                            W \ -_vec(dt_int * integrator.fsalfirst),
                            axes(uprev)
                        ) # Euler starting step
                        diff1 = u_temp3 - u_temp4
                        for j in 2:(j_int + 1)
                            T[index + 1] = u_temp3 + _reshape(
                                W \
                                    -_vec(
                                    dt_int * f(
                                        u_temp3, p,
                                        t + (j - 1) * dt_int
                                    )
                                ),
                                axes(uprev)
                            )
                            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                            if (j == j_int + 1)
                                T[index + 1] = 0.25(T[index + 1] + 2 * u_temp3 + u_temp4)
                            end
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                diff2 = u_temp3 - u_temp4
                                if (
                                        integrator.opts.internalnorm(diff1, t) <
                                            integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            diff1 = u_temp3 - u_temp4
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, integrator = integrator, p = p, t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i)
                    for index in indices
                        index == -1 && continue
                        j_int = sequence_factor * subdividing_sequence[index + 1]
                        dt_int = dt / j_int # Stepsize of the ith internal discretisation
                        W = dt_int * J - integrator.f.mass_matrix
                        integrator.stats.nw += 1
                        u_temp4 = uprev
                        u_temp3 = u_temp4 +
                            _reshape(
                            W \ -_vec(dt_int * integrator.fsalfirst),
                            axes(uprev)
                        ) # Euler starting step
                        diff1 = u_temp3 - u_temp4
                        for j in 2:(j_int + 1)
                            T[index + 1] = u_temp3 + _reshape(
                                W \
                                    -_vec(
                                    dt_int * f(
                                        u_temp3, p,
                                        t + (j - 1) * dt_int
                                    )
                                ),
                                axes(uprev)
                            )
                            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                            if (j == j_int + 1)
                                T[index + 1] = 0.25(T[index + 1] + 2 * u_temp3 + u_temp4)
                            end
                            u_temp4 = u_temp3
                            u_temp3 = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                diff2 = u_temp3 - u_temp4
                                if (
                                        integrator.opts.internalnorm(diff1, t) <
                                            integrator.opts.internalnorm(0.5 * (diff2 - diff1), t)
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            diff1 = u_temp3 - u_temp4
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        end
    end

    if integrator.force_stepfail
        return
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min
            u = eltype(uprev).(extrapolation_scalars[i + 1]) *
                sum(
                broadcast(
                    *, T[1:(i + 1)],
                    eltype(uprev).(extrapolation_weights[1:(i + 1), (i + 1)])
                )
            ) # Approximation of extrapolation order i
            utilde = eltype(uprev).(extrapolation_scalars_2[i]) *
                sum(
                broadcast(
                    *, T[2:(i + 1)],
                    eltype(uprev).(extrapolation_weights_2[1:i, i])
                )
            ) # and its internal counterpart
            # FIXME this should be stored in the controller cache
            res = calculate_residuals(
                u, utilde, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(res, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) ||
                    integrator.EEst <=
                    typeof(integrator.EEst)(
                    prod(
                        subdividing_sequence[(n_curr + 2):(win_max + 1)] .//
                            subdividing_sequence[1]^2
                    )
                )
                # Reject current approximation order but pass convergence monitor
                # Always compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update T
                j_int = sequence_factor * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                W = dt_int * J - integrator.f.mass_matrix
                integrator.stats.nw += 1
                u_temp2 = uprev
                u_temp1 = u_temp2 +
                    _reshape(W \ -_vec(dt_int * integrator.fsalfirst), axes(uprev)) # Euler starting step
                for j in 2:(j_int + 1)
                    T[n_curr + 1] = u_temp1 + _reshape(
                        W \
                            -_vec(
                            dt_int *
                                f(u_temp1, p, t + (j - 1) * dt_int)
                        ),
                        axes(uprev)
                    )
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    if (j == j_int + 1)
                        T[n_curr + 1] = 0.25(T[n_curr + 1] + 2 * u_temp1 + u_temp2)
                    end
                    u_temp2 = u_temp1
                    u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
                    sum(
                    broadcast(
                        *, T[1:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights[
                                1:(n_curr + 1),
                                (n_curr + 1),
                            ]
                        )
                    )
                ) # Approximation of extrapolation order n_curr
                utilde = eltype(uprev).(extrapolation_scalars_2[n_curr]) *
                    sum(
                    broadcast(
                        *, T[2:(n_curr + 1)],
                        eltype(uprev).(
                            extrapolation_weights_2[
                                1:n_curr,
                                n_curr,
                            ]
                        )
                    )
                ) # and its internal counterpart
                # FIXME this should be stored in the controller cache
                res = calculate_residuals(
                    u, utilde, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(res, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else
        u = eltype(uprev).(extrapolation_scalars[n_curr + 1]) *
            sum(
            broadcast(
                *, T[1:(n_curr + 1)],
                eltype(uprev).(
                    extrapolation_weights[
                        1:(n_curr + 1),
                        (n_curr + 1),
                    ]
                )
            )
        ) # Approximation of extrapolation order n_curr
    end

    # Save the latest approximation and update FSAL
    integrator.u = u
    integrator.fsallast = f(u, p, t + dt)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function initialize!(integrator, cache::ImplicitEulerBarycentricExtrapolationCache)
    # cf. initialize! of MidpointCache
    (; k, fsalfirst) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
end

function perform_step!(
        integrator, cache::ImplicitEulerBarycentricExtrapolationCache,
        repeat_step = false
    )
    # Unpack all information needed
    (; t, uprev, dt, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; n_curr, u_temp1, u_temp2, utilde, T, fsalfirst, k, diff1, diff2) = cache
    (; u_temp3, u_temp4, k_tmps) = cache
    # Coefficients for obtaining u
    (; extrapolation_weights, extrapolation_scalars) = cache.coefficients
    # Coefficients for obtaining utilde
    (; extrapolation_weights_2, extrapolation_scalars_2) = cache.coefficients
    # Additional constant information
    (; subdividing_sequence) = cache.coefficients
    (; sequence_factor) = alg

    (; J, W, uf, tf, linsolve_tmps, jac_config) = cache

    fill!(cache.Q, zero(eltype(cache.Q)))

    win_min = nothing
    win_max = nothing
    if integrator.opts.adaptive
        # Set up the order window
        # alg.min_order + 1 ≦ n_curr ≦ alg.max_order - 1 is enforced by step_*_controller!
        if !(alg.min_order + 1 <= n_curr <= alg.max_order - 1)
            error("Something went wrong while setting up the order window: $n_curr ∉ [$(alg.min_order + 1),$(alg.max_order - 1)].
            Please report this error  ")
        end
        win_min = n_curr - 1
        win_max = n_curr + 1

        # Set up the current extrapolation order
        cache.n_old = n_curr # Save the suggested order for step_*_controller!
        n_curr = win_min # Start with smallest order in the order window
    end

    #Compute the internal discretisations
    calc_J!(J, integrator, cache) # Store the calculated jac as it won't change in internal discretisation
    if !isthreaded(alg.threading)
        for i in 0:n_curr
            j_int = sequence_factor * subdividing_sequence[i + 1]
            dt_int = dt / j_int # Stepsize of the ith internal discretisation
            jacobian2W!(W[1], integrator.f.mass_matrix, dt_int, J)
            integrator.stats.nw += 1
            @.. broadcast = false u_temp2 = uprev
            @.. broadcast = false linsolve_tmps[1] = fsalfirst

            linsolve = cache.linsolve[1]

            if !repeat_step
                linres = dolinsolve(
                    integrator, linsolve; A = W[1],
                    b = _vec(linsolve_tmps[1]), linu = _vec(k)
                )
            else
                linres = dolinsolve(
                    integrator, linsolve; A = nothing,
                    b = _vec(linsolve_tmps[1]), linu = _vec(k)
                )
            end
            cache.linsolve[1] = linres.cache

            integrator.stats.nsolve += 1
            @.. broadcast = false u_temp1 = u_temp2 - k # Euler starting step
            @.. broadcast = false diff1[1] = u_temp1 - u_temp2
            for j in 2:(j_int + 1)
                f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                @.. broadcast = false linsolve_tmps[1] = k

                linsolve = cache.linsolve[1]
                if !repeat_step && j == 1
                    linres = dolinsolve(
                        integrator, linsolve; A = W[1],
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                else
                    linres = dolinsolve(
                        integrator, linsolve; A = nothing,
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                end
                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false T[i + 1] = u_temp1 - k
                if (j == j_int + 1)
                    @.. broadcast = false T[i + 1] = 0.25(T[i + 1] + 2 * u_temp1 + u_temp2)
                end
                @.. broadcast = false u_temp2 = u_temp1
                @.. broadcast = false u_temp1 = T[i + 1]
                if (i <= 1)
                    # Deuflhard Stability check for initial two sequences
                    @.. broadcast = false diff2[1] = u_temp1 - u_temp2
                    @.. broadcast = false diff2[1] = 0.5 * (diff2[1] - diff1[1])
                    if (
                            integrator.opts.internalnorm(diff1[1], t) <
                                integrator.opts.internalnorm(diff2[1], t)
                        )
                        # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                        integrator.force_stepfail = true
                        return
                    end
                end
                @.. broadcast = false diff1[1] = u_temp1 - u_temp2
            end
        end
    else
        if alg.sequence == :romberg
            # Compute solution by using maximum two threads for romberg sequence
            # One thread will fill T matrix till second last element and another thread will
            # fill last element of T matrix.
            # Romberg sequence --> 1, 2, 4, 8, ..., 2^(i)
            # 1 + 2 + 4 + ... + 2^(i-1) = 2^(i) - 1
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 1:2
                    startIndex = (i == 1) ? 0 : n_curr
                    endIndex = (i == 1) ? n_curr - 1 : n_curr

                    for index in startIndex:endIndex
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        jacobian2W!(
                            W[Threads.threadid()], integrator.f.mass_matrix,
                            dt_int_temp, J
                        )
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false linsolve_tmps[Threads.threadid()] = fsalfirst

                        linsolve = cache.linsolve[Threads.threadid()]

                        if !repeat_step
                            linres = dolinsolve(
                                integrator, linsolve;
                                A = W[Threads.threadid()],
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        end
                        cache.linsolve[Threads.threadid()] = linres.cache

                        @.. broadcast = false k_tmps[Threads.threadid()] = -k_tmps[Threads.threadid()]
                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] -
                            k_tmps[Threads.threadid()] # Euler starting step
                        @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                            u_temp4[Threads.threadid()]
                        for j in 2:(j_int_temp + 1)
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false linsolve_tmps[Threads.threadid()] = k_tmps[Threads.threadid()]

                            linsolve = cache.linsolve[Threads.threadid()]

                            if !repeat_step && j == 1
                                linres = dolinsolve(
                                    integrator, linsolve;
                                    A = W[Threads.threadid()],
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            else
                                linres = dolinsolve(
                                    integrator, linsolve; A = nothing,
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            end
                            cache.linsolve[Threads.threadid()] = linres.cache

                            @.. broadcast = false T[index + 1] = u_temp3[Threads.threadid()] -
                                k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            if (j == j_int_temp + 1)
                                @.. broadcast = false T[index + 1] = 0.25(
                                    T[index + 1] +
                                        2 *
                                        u_temp3[Threads.threadid()] +
                                        u_temp4[Threads.threadid()]
                                )
                            end
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                @.. broadcast = false diff2[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                                @.. broadcast = false diff2[Threads.threadid()] = 0.5 *
                                    (
                                    diff2[Threads.threadid()] -
                                        diff1[Threads.threadid()]
                                )
                                if (
                                        integrator.opts.internalnorm(
                                            diff1[Threads.threadid()],
                                            t
                                        ) <
                                            integrator.opts.internalnorm(
                                            diff2[Threads.threadid()],
                                            t
                                        )
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                u_temp4[Threads.threadid()]
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        else
            let n_curr = n_curr, subdividing_sequence = subdividing_sequence, uprev = uprev,
                    dt = dt, u_temp3 = u_temp3, u_temp4 = u_temp4, k_tmps = k_tmps, p = p,
                    t = t, T = T

                @threaded alg.threading for i in 0:(n_curr ÷ 2)
                    indices = i != n_curr - i ? (i, n_curr - i) : (-1, n_curr - i)
                    for index in indices
                        index == -1 && continue
                        j_int_temp = sequence_factor * subdividing_sequence[index + 1]
                        dt_int_temp = dt / j_int_temp # Stepsize of the ith internal discretisation
                        jacobian2W!(
                            W[Threads.threadid()], integrator.f.mass_matrix,
                            dt_int_temp, J
                        )
                        @.. broadcast = false u_temp4[Threads.threadid()] = uprev
                        @.. broadcast = false linsolve_tmps[Threads.threadid()] = fsalfirst

                        linsolve = cache.linsolve[Threads.threadid()]

                        if !repeat_step
                            linres = dolinsolve(
                                integrator, linsolve;
                                A = W[Threads.threadid()],
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        else
                            linres = dolinsolve(
                                integrator, linsolve; A = nothing,
                                b = _vec(linsolve_tmps[Threads.threadid()]),
                                linu = _vec(k_tmps[Threads.threadid()])
                            )
                        end
                        cache.linsolve[Threads.threadid()] = linres.cache

                        @.. broadcast = false u_temp3[Threads.threadid()] = u_temp4[Threads.threadid()] -
                            k_tmps[Threads.threadid()] # Euler starting step
                        @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                            u_temp4[Threads.threadid()]
                        for j in 2:(j_int_temp + 1)
                            f(
                                k_tmps[Threads.threadid()],
                                cache.u_temp3[Threads.threadid()],
                                p, t + (j - 1) * dt_int_temp
                            )
                            @.. broadcast = false linsolve_tmps[Threads.threadid()] = k_tmps[Threads.threadid()]

                            linsolve = cache.linsolve[Threads.threadid()]

                            if (!repeat_step && j == 1)
                                linres = dolinsolve(
                                    integrator, linsolve;
                                    A = W[Threads.threadid()],
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            else
                                linres = dolinsolve(
                                    integrator, linsolve; A = nothing,
                                    b = _vec(linsolve_tmps[Threads.threadid()]),
                                    linu = _vec(k_tmps[Threads.threadid()])
                                )
                            end
                            cache.linsolve[Threads.threadid()] = linres.cache

                            @.. broadcast = false T[index + 1] = u_temp3[Threads.threadid()] -
                                k_tmps[Threads.threadid()] # Explicit Midpoint rule
                            if (j == j_int_temp + 1)
                                @.. broadcast = false T[index + 1] = 0.25(
                                    T[index + 1] +
                                        2 *
                                        u_temp3[Threads.threadid()] +
                                        u_temp4[Threads.threadid()]
                                )
                            end
                            @.. broadcast = false u_temp4[Threads.threadid()] = u_temp3[Threads.threadid()]
                            @.. broadcast = false u_temp3[Threads.threadid()] = T[index + 1]
                            if (index <= 1)
                                # Deuflhard Stability check for initial two sequences
                                @.. broadcast = false diff2[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                    u_temp4[Threads.threadid()]
                                @.. broadcast = false diff2[Threads.threadid()] = 0.5 *
                                    (
                                    diff2[Threads.threadid()] -
                                        diff1[Threads.threadid()]
                                )
                                if (
                                        integrator.opts.internalnorm(
                                            diff1[Threads.threadid()],
                                            t
                                        ) <
                                            integrator.opts.internalnorm(
                                            diff2[Threads.threadid()],
                                            t
                                        )
                                    )
                                    # Divergence of iteration, overflow is possible. Force fail and start with smaller step
                                    integrator.force_stepfail = true
                                    return
                                end
                            end
                            @.. broadcast = false diff1[Threads.threadid()] = u_temp3[Threads.threadid()] -
                                u_temp4[Threads.threadid()]
                        end
                    end
                    integrator.force_stepfail ? break : continue
                end
            end
        end
    end

    if integrator.force_stepfail
        return
    end

    if integrator.opts.adaptive
        # Compute all information relating to an extrapolation order ≦ win_min
        for i in (win_min - 1):win_min

            #integrator.u .= extrapolation_scalars[i+1] * sum( broadcast(*, cache.T[1:(i+1)], extrapolation_weights[1:(i+1), (i+1)]) ) # Approximation of extrapolation order i
            #cache.utilde .= extrapolation_scalars_2[i] * sum( broadcast(*, cache.T[2:(i+1)], extrapolation_weights_2[1:i, i]) ) # and its internal counterpart

            u_temp1 .= false
            u_temp2 .= false
            for j in 1:(i + 1)
                @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (i + 1)]
            end
            for j in 2:(i + 1)
                @.. broadcast = false u_temp2 += cache.T[j] * extrapolation_weights_2[j - 1, i]
            end
            @.. broadcast = false integrator.u = extrapolation_scalars[i + 1] * u_temp1
            @.. broadcast = false cache.utilde = extrapolation_scalars_2[i] * u_temp2

            calculate_residuals!(
                cache.atmp, integrator.u, cache.utilde,
                integrator.opts.abstol, integrator.opts.reltol,
                integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
            cache.n_curr = i # Update cache's n_curr for stepsize_controller_internal!
            stepsize_controller_internal!(integrator, alg) # Update cache.Q
        end

        # Check if an approximation of some order in the order window can be accepted
        # Make sure a stepsize scaling factor of order (alg.min_order + 1) is provided for the step_*_controller!
        while n_curr <= win_max
            EEst1 = one(integrator.EEst)
            for i in (n_curr + 2):(win_max + 1)
                EEst1 *= subdividing_sequence[i] / subdividing_sequence[1]
            end
            EEst1 *= EEst1

            #@show integrator.opts.internalnorm(integrator.u - cache.utilde,t)
            if accept_step_controller(integrator, integrator.opts.controller)
                # Accept current approximation u of order n_curr
                break
            elseif (n_curr < alg.min_order + 1) || integrator.EEst <= EEst1
                # Reject current approximation order but pass convergence monitor
                # Compute approximation of order (n_curr + 1)
                n_curr = n_curr + 1
                cache.n_curr = n_curr

                # Update cache.T
                j_int = sequence_factor * subdividing_sequence[n_curr + 1]
                dt_int = dt / j_int # Stepsize of the new internal discretisation
                jacobian2W!(W[1], integrator.f.mass_matrix, dt_int, J)
                integrator.stats.nw += 1
                @.. broadcast = false u_temp2 = uprev
                @.. broadcast = false linsolve_tmps[1] = fsalfirst

                linsolve = cache.linsolve[1]

                if !repeat_step
                    linres = dolinsolve(
                        integrator, linsolve; A = W[1],
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                else
                    linres = dolinsolve(
                        integrator, linsolve; A = nothing,
                        b = _vec(linsolve_tmps[1]), linu = _vec(k)
                    )
                end
                cache.linsolve[1] = linres.cache

                integrator.stats.nsolve += 1
                @.. broadcast = false k = -k
                @.. broadcast = false u_temp1 = u_temp2 + k # Euler starting step
                for j in 2:(j_int + 1)
                    f(k, cache.u_temp1, p, t + (j - 1) * dt_int)
                    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
                    @.. broadcast = false linsolve_tmps[1] = k

                    linsolve = cache.linsolve[1]
                    linres = dolinsolve(
                        integrator, linsolve; b = _vec(linsolve_tmps[1]),
                        linu = _vec(k)
                    )
                    cache.linsolve[1] = linres.cache

                    integrator.stats.nsolve += 1
                    @.. broadcast = false T[n_curr + 1] = u_temp1 - k # Explicit Midpoint rule
                    if (j == j_int + 1)
                        @.. broadcast = false T[n_curr + 1] = 0.25(
                            T[n_curr + 1] + 2 * u_temp1 +
                                u_temp2
                        )
                    end
                    @.. broadcast = false u_temp2 = u_temp1
                    @.. broadcast = false u_temp1 = T[n_curr + 1]
                end

                # Update u, integrator.EEst and cache.Q
                #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
                #cache.utilde .= extrapolation_scalars_2[n_curr] * sum( broadcast(*, cache.T[2:(n_curr+1)], extrapolation_weights_2[1:n_curr, n_curr]) ) # and its internal counterpart

                u_temp1 .= false
                u_temp2 .= false
                for j in 1:(n_curr + 1)
                    @.. broadcast = false u_temp1 += cache.T[j] *
                        extrapolation_weights[j, (n_curr + 1)]
                end
                for j in 2:(n_curr + 1)
                    @.. broadcast = false u_temp2 += cache.T[j] *
                        extrapolation_weights_2[j - 1, n_curr]
                end
                @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
                @.. broadcast = false cache.utilde = extrapolation_scalars_2[n_curr] * u_temp2

                calculate_residuals!(
                    cache.atmp, integrator.u, cache.utilde,
                    integrator.opts.abstol, integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                integrator.EEst = integrator.opts.internalnorm(cache.atmp, t)
                stepsize_controller_internal!(integrator, alg) # Update cache.Q
            else
                # Reject the current approximation and not pass convergence monitor
                break
            end
        end
    else

        #integrator.u .= extrapolation_scalars[n_curr+1] * sum( broadcast(*, cache.T[1:(n_curr+1)], extrapolation_weights[1:(n_curr+1), (n_curr+1)]) ) # Approximation of extrapolation order n_curr
        u_temp1 .= false
        for j in 1:(n_curr + 1)
            @.. broadcast = false u_temp1 += cache.T[j] * extrapolation_weights[j, (n_curr + 1)]
        end
        @.. broadcast = false integrator.u = extrapolation_scalars[n_curr + 1] * u_temp1
    end

    f(cache.k, integrator.u, p, t + dt) # Update FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# Import packages
using OrdinaryDiffEqExtrapolation, RecursiveFactorization, DiffEqDevTools, Test, Random

println("Running on $(Threads.nthreads()) thread(s).")

# Define test problems
# Note that the time span in ODEProblemLibrary is given by
# Float64 numbers

linear = (u, p, t) -> (p * u)
linear_analytic = (u0, p, t) -> u0 * exp(p * t)
prob_ode_bigfloatlinear = ODEProblem(
    ODEFunction(linear, analytic = linear_analytic),
    big"0.5", (big"0.0", big"1.0"), big"1.01"
)

f_2dlinear = (du, u, p, t) -> (@. du = p * u)
f_2dlinear_analytic = (u0, p, t) -> @. u0 * exp(p * t)
prob_ode_bigfloat2Dlinear = ODEProblem(
    ODEFunction(
        f_2dlinear,
        analytic = f_2dlinear_analytic
    ),
    rand(BigFloat, (4, 2)), (big"0.0", big"1.0"),
    big"1.01"
)

# Prepare tests
Random.seed!(100)
problem_array = [prob_ode_bigfloatlinear, prob_ode_bigfloat2Dlinear]
dts = 1 .// 2 .^ (8:-1:1)

testTol = 0.2

@testset "Testing extrapolation methods" begin

    # Test AitkenNeville
    @testset "Testing AitkenNeville" begin
        @testset "Testing sequential AitkenNeville" begin
            for prob in problem_array
                global dts

                #  Convergence test
                for j in 1:4
                    sim = test_convergence(
                        dts, prob,
                        AitkenNeville(
                            max_order = j,
                            min_order = j, init_order = j,
                            threading = false
                        )
                    )
                    @test sim.𝒪est[:final] ≈ j atol = testTol
                end

                # Regression test
                sol = solve(
                    prob,
                    AitkenNeville(
                        max_order = 9, min_order = 1,
                        init_order = 9, threading = false
                    ), reltol = 1.0e-3
                )
                @test length(sol.u) < 15
                @test SciMLBase.successful_retcode(sol)
                @test SciMLBase.successful_retcode(sol)
                sol = solve(
                    prob,
                    AitkenNeville(
                        max_order = 9, min_order = 1,
                        init_order = 9, threading = false
                    ), reltol = 1.0e-6
                )
                @test length(sol.u) < 18
                @test SciMLBase.successful_retcode(sol)
            end
        end
        @testset "Testing threaded AitkenNeville" begin
            for prob in problem_array
                global dts

                #  Convergence test
                for j in 1:4
                    sim = test_convergence(
                        dts, prob,
                        AitkenNeville(
                            max_order = j,
                            min_order = j, init_order = j,
                            threading = true
                        )
                    )
                    @test sim.𝒪est[:final] ≈ j atol = testTol
                end

                # Regression test
                sol = solve(
                    prob,
                    AitkenNeville(
                        max_order = 9, min_order = 1,
                        init_order = 9, threading = true
                    ), reltol = 1.0e-3
                )
                @test length(sol.u) < 15
                @test SciMLBase.successful_retcode(sol)
                @test SciMLBase.successful_retcode(sol)
                sol = solve(
                    prob,
                    AitkenNeville(
                        max_order = 9, min_order = 1,
                        init_order = 9, threading = true
                    ), reltol = 1.0e-6
                )
                @test length(sol.u) < 18
                @test SciMLBase.successful_retcode(sol)
            end
        end
    end # AitkenNeville

    # Define the subdividing sequences
    sequence_array = [:harmonic, :romberg, :bulirsch]

    @testset "Testing ImplicitEulerExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            newTol = 0.35
            #  Convergence test
            for j in 1:4
                alg = ImplicitEulerExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq, threading = false
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ alg.init_order + 1.1 atol = newTol #Superconvergence
            end
            # Regression test
            sol = solve(
                prob,
                ImplicitEulerExtrapolation(
                    max_order = 9, min_order = 1,
                    init_order = 9, sequence = seq,
                    threading = false
                ), reltol = 1.0e-3
            )
            @test length(sol.u) < 15
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitEulerExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            newTol = 0.35
            #  Convergence test
            for j in 1:4
                alg = ImplicitEulerExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq, threading = true
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ alg.init_order + 1.1 atol = newTol #Superconvergence
            end
            # Regression test
            sol = solve(
                prob,
                ImplicitEulerExtrapolation(
                    max_order = 9, min_order = 1,
                    init_order = 9, sequence = seq,
                    threading = true
                ), reltol = 1.0e-3
            )
            @test length(sol.u) < 15
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitEulerBarycentricExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            newTol = 0.35
            #  Convergence test
            for j in 1:4
                alg = ImplicitEulerBarycentricExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq,
                    threading = false
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ alg.init_order + 0.5 atol = newTol #Superconvergence
            end
            # Regression test
            sol = solve(
                prob,
                ImplicitEulerBarycentricExtrapolation(
                    max_order = 9, min_order = 1,
                    init_order = 9,
                    sequence = seq,
                    threading = false
                ),
                reltol = 1.0e-3
            )
            @test length(sol.u) < 15
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitEulerBarycentricExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            newTol = 0.35
            #  Convergence test
            for j in 1:4
                alg = ImplicitEulerBarycentricExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq,
                    threading = true
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ alg.init_order + 0.5 atol = newTol #Superconvergence
                algp = ImplicitEulerBarycentricExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq,
                    threading = OrdinaryDiffEqExtrapolation.PolyesterThreads()
                )
                simp = test_convergence(dts, prob, algp)
                @test simp.𝒪est[:final] ≈ algp.init_order + 0.5 atol = newTol #Superconvergence
            end
            # Regression test
            sol = solve(
                prob,
                ImplicitEulerBarycentricExtrapolation(
                    max_order = 9, min_order = 1,
                    init_order = 9,
                    sequence = seq,
                    threading = true
                ),
                reltol = 1.0e-3
            )
            @test length(sol.u) < 15
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitDeuflhardExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            # Convergence test
            for j in 1:6
                alg = ImplicitDeuflhardExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq,
                    threading = OrdinaryDiffEqExtrapolation.Sequential()
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) atol = testTol
            end

            # Regression test
            alg = ImplicitDeuflhardExtrapolation(
                max_order = 9, min_order = 1,
                init_order = 9, sequence = seq,
                threading = false
            )
            sol = solve(prob, alg, reltol = 1.0e-3)
            @test length(sol.u) < 10
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitDeuflhardExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            # Convergence test
            for j in 1:6
                alg = ImplicitDeuflhardExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq, threading = true
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) atol = testTol
            end

            # Regression test
            alg = ImplicitDeuflhardExtrapolation(
                max_order = 9, min_order = 1,
                init_order = 9, sequence = seq,
                threading = OrdinaryDiffEqExtrapolation.BaseThreads()
            )
            sol = solve(prob, alg, reltol = 1.0e-3)
            @test length(sol.u) < 10
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitHairerWannerExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            # Convergence test
            for j in 1:6
                alg = ImplicitHairerWannerExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq, threading = false
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) - 1 atol = testTol
            end

            alg = ImplicitHairerWannerExtrapolation(
                max_order = 9, min_order = 1,
                init_order = 9, sequence = seq,
                threading = false
            )
            sol = solve(prob, alg, reltol = 1.0e-3)
            @test length(sol.u) < 10
            @test SciMLBase.successful_retcode(sol)
        end
    end

    @testset "Testing ImplicitHairerWannerExtrapolation" begin
        for prob in problem_array,
                seq in sequence_array

            global dts

            # Convergence test
            for j in 1:6
                alg = ImplicitHairerWannerExtrapolation(
                    min_order = j,
                    init_order = j, max_order = j,
                    sequence = seq,
                    threading = OrdinaryDiffEqExtrapolation.PolyesterThreads()
                )
                sim = test_convergence(dts, prob, alg)
                @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) - 1 atol = testTol
            end

            alg = ImplicitHairerWannerExtrapolation(
                max_order = 9, min_order = 1,
                init_order = 9, sequence = seq,
                threading = true
            )
            sol = solve(prob, alg, reltol = 1.0e-3)
            @test length(sol.u) < 10
            @test SciMLBase.successful_retcode(sol)
        end
    end

    # Test ExtrapolationMidpointDeuflhard
    @testset "Testing ExtrapolationMidpointDeuflhard" begin
        @testset "Testing sequential ExtrapolationMidpointDeuflhard" begin
            for prob in problem_array,
                    seq in sequence_array

                global dts

                # Convergence test
                for j in 1:6
                    alg = ExtrapolationMidpointDeuflhard(
                        min_order = j,
                        init_order = j, max_order = j,
                        sequence = seq,
                        threading = OrdinaryDiffEqExtrapolation.Sequential()
                    )
                    sim = test_convergence(dts, prob, alg)
                    @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) atol = testTol
                end

                # Regression test
                alg = ExtrapolationMidpointDeuflhard(
                    max_order = 9, min_order = 1,
                    init_order = 9, sequence = seq,
                    threading = false
                )
                sol = solve(prob, alg, reltol = 1.0e-3)
                @test length(sol.u) < 10
                @test SciMLBase.successful_retcode(sol)
                @test SciMLBase.successful_retcode(sol)
            end
        end
        @testset "Testing threaded ExtrapolationMidpointDeuflhard" begin
            for prob in problem_array,
                    seq in sequence_array

                global dts

                # Convergence test
                for j in 1:6
                    alg = ExtrapolationMidpointDeuflhard(
                        min_order = j,
                        init_order = j, max_order = j,
                        sequence = seq, threading = true
                    )
                    sim = test_convergence(dts, prob, alg)
                    @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) atol = testTol
                end

                # Regression test
                alg = ExtrapolationMidpointDeuflhard(
                    max_order = 9, min_order = 1,
                    init_order = 9, sequence = seq,
                    threading = true
                )
                sol = solve(prob, alg, reltol = 1.0e-3)
                @test length(sol.u) < 10
                @test SciMLBase.successful_retcode(sol)
                @test SciMLBase.successful_retcode(sol)
            end
        end
    end # ExtrapolationMidpointDeuflhard

    # Test ExtrapolationMidpointHairerWanner
    @testset "Testing ExtrapolationMidpointHairerWanner" begin
        @testset "Testing sequential ExtrapolationMidpointHairerWanner" begin
            for prob in problem_array,
                    seq in sequence_array

                global dts

                # Convergence test
                for j in 1:6
                    alg = ExtrapolationMidpointHairerWanner(
                        min_order = j,
                        init_order = j, max_order = j,
                        sequence = seq,
                        threading = false
                    )
                    sim = test_convergence(dts, prob, alg)
                    @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) atol = testTol
                end

                # Regression test
                alg = ExtrapolationMidpointHairerWanner(
                    max_order = 9, min_order = 2,
                    init_order = 9, sequence = seq,
                    threading = false
                )
                sol = solve(prob, alg, reltol = 1.0e-3)
                @test length(sol.u) < 10
                @test SciMLBase.successful_retcode(sol)
                @test SciMLBase.successful_retcode(sol)
            end
        end
        @testset "Testing threaded ExtrapolationMidpointHairerWanner" begin
            for prob in problem_array,
                    seq in sequence_array

                global dts

                # Convergence test
                for j in 1:6
                    alg = ExtrapolationMidpointHairerWanner(
                        min_order = j,
                        init_order = j, max_order = j,
                        sequence = seq,
                        threading = true
                    )
                    sim = test_convergence(dts, prob, alg)
                    @test sim.𝒪est[:final] ≈ 2 * (alg.init_order + 1) atol = testTol
                end

                # Regression test
                alg = ExtrapolationMidpointHairerWanner(
                    max_order = 9, min_order = 2,
                    init_order = 9, sequence = seq,
                    threading = true
                )
                sol = solve(prob, alg, reltol = 1.0e-3)
                @test length(sol.u) < 10
                @test SciMLBase.successful_retcode(sol)
                @test SciMLBase.successful_retcode(sol)
            end
        end
    end # ExtrapolationMidpointHairerWanner

    @testset "Regression Test Float32 and Float64 Fallbacks" begin
        prob_ode_2Dlinear = ODEProblem(
            ODEFunction(
                f_2dlinear,
                analytic = f_2dlinear_analytic
            ),
            Float64.(prob_ode_bigfloat2Dlinear.u0), (0.0, 1.0),
            1.01
        )
        s1 = solve(prob_ode_bigfloat2Dlinear, ExtrapolationMidpointDeuflhard())
        s2 = solve(prob_ode_2Dlinear, ExtrapolationMidpointDeuflhard())
        @test all(all(s1[i] - s2[i] .< 5.0e-14) for i in 1:length(s1))

        prob_ode_2Dlinear = ODEProblem(
            ODEFunction(
                f_2dlinear,
                analytic = f_2dlinear_analytic
            ),
            Float32.(prob_ode_bigfloat2Dlinear.u0),
            (0.0f0, 1.0f0), 1.01f0
        )
        s1 = solve(prob_ode_bigfloat2Dlinear, ExtrapolationMidpointDeuflhard())
        s2 = solve(prob_ode_2Dlinear, ExtrapolationMidpointDeuflhard())
        @test all(all(s1[i] - s2[i] .< 5.0e-6) for i in 1:length(s1))
    end

    # Test for Julia 1.12 threading compatibility (Issue #2612)
    @testset "Threading compatibility test" begin
        # Simple problem for threading test
        simple_prob = ODEProblem((u, p, t) -> u, 0.1, (0.0, 1.0))

        # Test extrapolation methods with threading enabled
        @testset "ExtrapolationMidpointDeuflhard with threading" begin
            sol = solve(
                simple_prob,
                ExtrapolationMidpointDeuflhard(threading = true),
                reltol = 1.0e-3
            )
            @test SciMLBase.successful_retcode(sol)
            @test length(sol) > 0
        end

        @testset "ImplicitEulerExtrapolation with threading" begin
            sol = solve(
                simple_prob,
                ImplicitEulerExtrapolation(threading = true),
                reltol = 1.0e-3
            )
            @test SciMLBase.successful_retcode(sol)
            @test length(sol) > 0
        end

        @testset "ImplicitDeuflhardExtrapolation with threading" begin
            sol = solve(
                simple_prob,
                ImplicitDeuflhardExtrapolation(threading = true),
                reltol = 1.0e-3
            )
            @test SciMLBase.successful_retcode(sol)
            @test length(sol) > 0
        end
    end
end # Extrapolation methods

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        # Extrapolation methods
        mutable struct ExtrapolationController{QT} <: AbstractLegacyController
            beta1::QT
        end

        struct NewExtrapolationController{QT} <: AbstractController
            qmin::QT
            qmax::QT
        end
    end
else
    @eval begin
        mutable struct ExtrapolationController{QT} <: AbstractController
            beta1::QT
        end
    end
end

function reset_alg_dependent_opts!(controller::ExtrapolationController, alg1, alg2)
    if controller.beta1 == beta1_default(alg1, beta2_default(alg1))
        controller.beta1 = beta1_default(alg2, beta2_default(alg2))
    end
    return nothing
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        function NewExtrapolationController(QT, alg; qmin = nothing, qmax = nothing, gamma = nothing)
            return NewExtrapolationController(
                QT(qmin === nothing ? qmin_default(alg) : qmin),
                QT(qmax === nothing ? qmax_default(alg) : qmax),
            )
        end

        mutable struct ExtrapolationControllerCache{QT, UT} <: AbstractControllerCache
            controller::NewExtrapolationController{QT}
            beta1::QT
            gamma::QT
            atmp::UT
        end

        function setup_controller_cache(alg, atmp, controller::NewExtrapolationController{T}) where {T}
            return ExtrapolationControllerCache(
                controller,
                T(1),
                T(1),
                atmp,
            )
        end
    end
end

# TODO replace this when done - right now this holds the controller cache!
stepsize_controller_internal!(integrator, alg) = stepsize_controller_internal!(integrator, integrator.opts.controller, alg)
stepsize_predictor!(integrator, alg, n_new) = stepsize_predictor!(integrator, integrator.opts.controller, alg, n_new)
# stepsize_controller_internal!(integrator, alg) = stepsize_controller_internal!(integrator, integrator.cache.controller_cache, alg)
# stepsize_predictor!(integrator, alg, n_new) = stepsize_predictor!(integrator, integrator.cache.controller_cache, alg, n_new)

@inline function stepsize_controller!(
        integrator,
        controller::ExtrapolationController,
        alg::Union{
            ExtrapolationMidpointDeuflhard,
            ImplicitDeuflhardExtrapolation,
        }
    )
    # Dummy function
    # ExtrapolationMidpointDeuflhard's stepsize scaling is stored in the cache;
    # it is computed by  stepsize_controller_internal! (in perform_step!) resp. stepsize_predictor!
    # (in step_accept_controller! and step_reject_controller!)
    return zero(typeof(integrator.opts.qmax))
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        @inline function stepsize_controller!(
                integrator,
                cache::ExtrapolationControllerCache,
                alg::Union{
                    ExtrapolationMidpointDeuflhard,
                    ImplicitDeuflhardExtrapolation,
                }
            )
            # Dummy function
            # ExtrapolationMidpointDeuflhard's stepsize scaling is stored in the cache;
            # it is computed by  stepsize_controller_internal! (in perform_step!) resp. stepsize_predictor!
            # (in step_accept_controller! and step_reject_controller!)
            return zero(typeof(cache.controller.qmax))
        end
    end
end

function stepsize_controller_internal!(
        integrator,
        controller::ExtrapolationController,
        alg::Union{
            ExtrapolationMidpointDeuflhard,
            ImplicitDeuflhardExtrapolation,
        }
    )
    # Standard step size controller
    # Compute and save the stepsize scaling based on the latest error estimate of the current order
    (; controller) = integrator.opts

    if iszero(integrator.EEst)
        q = inv(integrator.opts.qmax)
    else
        # Update gamma and beta1
        controller.beta1 = typeof(controller.beta1)(1 // (2integrator.cache.n_curr + 1))
        integrator.opts.gamma = FastPower.fastpower(
            typeof(integrator.opts.gamma)(1 // 4),
            controller.beta1
        )
        # Compute new stepsize scaling
        qtmp = FastPower.fastpower(integrator.EEst, controller.beta1) /
            integrator.opts.gamma
        @fastmath q = max(inv(integrator.opts.qmax), min(inv(integrator.opts.qmin), qtmp))
    end
    return integrator.cache.Q[integrator.cache.n_curr - alg.min_order + 1] = q
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        function stepsize_controller_internal!(
                integrator,
                cache::ExtrapolationControllerCache,
                alg::Union{
                    ExtrapolationMidpointDeuflhard,
                    ImplicitDeuflhardExtrapolation,
                }
            )
            # Standard step size controller
            # Compute and save the stepsize scaling based on the latest error estimate of the current order
            (; controller) = cache

            if iszero(integrator.EEst)
                q = inv(controller.qmax)
            else
                # Update gamma and beta1
                cache.beta1 = typeof(cache.beta1)(1 // (2integrator.cache.n_curr + 1))
                cache.gamma = FastPower.fastpower(
                    typeof(cache.gamma)(1 // 4),
                    cache.beta1
                )
                # Compute new stepsize scaling
                qtmp = FastPower.fastpower(integrator.EEst, cache.beta1) /
                    cache.gamma
                @fastmath q = max(inv(controller.qmax), min(inv(controller.qmin), qtmp))
            end
            return integrator.cache.Q[integrator.cache.n_curr - alg.min_order + 1] = q
        end
    end
end

function stepsize_predictor!(
        integrator,
        controller::ExtrapolationController,
        alg::Union{
            ExtrapolationMidpointDeuflhard,
            ImplicitDeuflhardExtrapolation,
        }, n_new::Int
    )
    # Compute and save the stepsize scaling for order n_new based on the latest error estimate of the current order.
    (; controller) = integrator.opts

    if iszero(integrator.EEst)
        q = inv(integrator.opts.qmax)
    else
        # Initialize
        (; t, EEst) = integrator
        (; stage_number) = integrator.cache
        tol = integrator.opts.internalnorm(integrator.opts.reltol, t) # Deuflhard's approach relies on EEstD ≈ ||relTol||
        s_curr = stage_number[integrator.cache.n_curr - alg.min_order + 1]
        s_new = stage_number[n_new - alg.min_order + 1]
        # Update gamma and beta1
        controller.beta1 = typeof(controller.beta1)(1 // (2integrator.cache.n_curr + 1))
        integrator.opts.gamma = FastPower.fastpower(
            typeof(integrator.opts.gamma)(1 // 4),
            controller.beta1
        )
        # Compute new stepsize scaling
        qtmp = EEst *
            FastPower.fastpower(
            FastPower.fastpower(tol, (1.0 - s_curr / s_new)),
            controller.beta1
        ) / integrator.opts.gamma
        @fastmath q = max(inv(integrator.opts.qmax), min(inv(integrator.opts.qmin), qtmp))
    end
    return integrator.cache.Q[n_new - alg.min_order + 1] = q
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        function stepsize_predictor!(
                integrator,
                cache::ExtrapolationControllerCache,
                alg::Union{
                    ExtrapolationMidpointDeuflhard,
                    ImplicitDeuflhardExtrapolation,
                }, n_new::Int
            )
            # Compute and save the stepsize scaling for order n_new based on the latest error estimate of the current order.
            (; controller) = cache

            if iszero(integrator.EEst)
                q = inv(controller.qmax)
            else
                # Initialize
                (; t, EEst) = integrator
                (; stage_number) = integrator.cache
                tol = integrator.opts.internalnorm(integrator.opts.reltol, t) # Deuflhard's approach relies on EEstD ≈ ||relTol||
                s_curr = stage_number[integrator.cache.n_curr - alg.min_order + 1]
                s_new = stage_number[n_new - alg.min_order + 1]
                # Update gamma and beta1
                cache.beta1 = typeof(cache.beta1)(1 // (2integrator.cache.n_curr + 1))
                cache.gamma = FastPower.fastpower(
                    typeof(cache.gamma)(1 // 4),
                    cache.beta1
                )
                # Compute new stepsize scaling
                qtmp = EEst *
                    FastPower.fastpower(
                    FastPower.fastpower(tol, (1.0 - s_curr / s_new)),
                    cache.beta1
                ) / cache.gamma
                @fastmath q = max(inv(controller.qmax), min(inv(controller.qmin), qtmp))
            end
            return integrator.cache.Q[n_new - alg.min_order + 1] = q
        end
    end
end

function step_accept_controller!(
        integrator,
        alg::Union{
            ExtrapolationMidpointDeuflhard,
            ImplicitDeuflhardExtrapolation,
        }, q
    )
    # Compute new order and stepsize, return new stepsize
    (; min_order, max_order) = alg
    (; n_curr, n_old, Q) = integrator.cache
    s = integrator.cache.stage_number

    # Compute new order based on available quantities
    tmp = (min_order:n_curr) .- min_order .+ 1 # Index range of quantities computed so far
    dt_new = Vector{eltype(Q)}(undef, length(tmp) + 1)
    dt_new[1:(end - 1)] = integrator.dt ./ Q[tmp] # Store for the possible new stepsizes
    dtmin = timedepentdtmin(integrator)
    dt_new[1:(end - 1)] = max.(
        dtmin,
        min.(abs(integrator.opts.dtmax), abs.(dt_new[1:(end - 1)]))
    ) # Safety scaling

    # n_new is the most efficient order of the last step
    work = s[tmp] ./ dt_new[1:(end - 1)]
    n_new = argmin(work) + min_order - 1

    # Check if n_new may be increased
    if n_new == n_curr < min(max_order, n_old + 1) # cf. win_max in perform_step! of the last step
        # Predict stepsize scaling for order (n_new + 1)
        stepsize_predictor!(integrator, alg, n_new + 1) # Update cache.Q

        # Compute and scale the corresponding stepsize
        dt_new[end] = integrator.dt ./ Q[tmp[end] + 1]
        dt_new[end] = max(dtmin, min(abs(integrator.opts.dtmax), abs.(dt_new[end])))

        # Check if (n_new  + 1) would have been more efficient than n_new
        if work[end] > s[tmp[end] + 1] / dt_new[end]
            n_new = n_new + 1
        end
    end

    integrator.cache.n_curr = n_new
    return dt_new[n_new - min_order + 1]
end

function step_reject_controller!(
        integrator,
        alg::Union{
            ExtrapolationMidpointDeuflhard,
            ImplicitDeuflhardExtrapolation,
        }
    )
    # Compute and save reduced stepsize dt_red of order n_old
    # Use the latest error estimate to predict dt_red if an estimate of order n_old is not available
    if integrator.cache.n_curr < integrator.cache.n_old
        stepsize_predictor!(integrator, alg, integrator.cache.n_old) # Update cache.Q
    end
    integrator.cache.n_curr = integrator.cache.n_old # Reset order for redoing the rejected step
    dt_red = integrator.dt /
        integrator.cache.Q[integrator.cache.n_old - integrator.alg.min_order + 1]
    dtmin = timedepentdtmin(integrator)
    dt_red = integrator.tdir * max(dtmin, min(abs(integrator.opts.dtmax), abs(dt_red))) # Safety scaling
    return integrator.dt = dt_red
end

@inline function stepsize_controller!(
        integrator,
        alg::Union{
            ExtrapolationMidpointHairerWanner,
            ImplicitHairerWannerExtrapolation,
            ImplicitEulerExtrapolation,
            ImplicitEulerBarycentricExtrapolation,
        }
    )
    # Dummy function
    # ExtrapolationMidpointHairerWanner's stepsize scaling is stored in the cache;
    # it is computed by  stepsize_controller_internal! (in perform_step!), step_accept_controller! or step_reject_controller!
    return zero(typeof(integrator.opts.qmax))
end

function stepsize_controller_internal!(
        integrator,
        controller::ExtrapolationController,
        alg::Union{
            ExtrapolationMidpointHairerWanner,
            ImplicitHairerWannerExtrapolation,
            ImplicitEulerExtrapolation,
            ImplicitEulerBarycentricExtrapolation,
        }
    )
    # Standard step size controller
    # Compute and save the stepsize scaling based on the latest error estimate of the current order
    (; controller) = integrator.opts

    return if alg isa
            Union{
            ImplicitEulerExtrapolation, ImplicitEulerBarycentricExtrapolation,
            ImplicitHairerWannerExtrapolation,
        }
        if iszero(integrator.EEst)
            q = inv(integrator.opts.qmax)
        else
            # Update gamma and beta1
            if alg isa ImplicitHairerWannerExtrapolation
                controller.beta1 = typeof(controller.beta1)(
                    1 //
                        (2integrator.cache.n_curr + 1)
                )
            elseif alg isa ImplicitEulerExtrapolation
                controller.beta1 = typeof(controller.beta1)(1 // (integrator.cache.n_curr))
            else
                controller.beta1 = typeof(controller.beta1)(
                    1 //
                        (integrator.cache.n_curr - 1)
                )
            end
            integrator.opts.gamma = FastPower.fastpower(
                typeof(integrator.opts.gamma)(
                    65 //
                        100
                ),
                controller.beta1
            )
            # Compute new stepsize scaling
            qtmp = FastPower.fastpower(integrator.EEst, controller.beta1) /
                (integrator.opts.gamma)
            @fastmath q = max(
                inv(integrator.opts.qmax),
                min(inv(integrator.opts.qmin), qtmp)
            )
        end
        integrator.cache.Q[integrator.cache.n_curr + 1] = q
    else
        if iszero(integrator.EEst)
            q = inv(integrator.opts.qmax)
        else
            # Update gamma and beta1
            controller.beta1 = typeof(controller.beta1)(1 // (2integrator.cache.n_curr + 1))
            integrator.opts.gamma = FastPower.fastpower(
                typeof(integrator.opts.gamma)(
                    65 //
                        100
                ),
                controller.beta1
            )
            # Compute new stepsize scaling
            qtmp = FastPower.fastpower(integrator.EEst, controller.beta1) /
                integrator.opts.gamma
            @fastmath q = max(
                inv(integrator.opts.qmax),
                min(inv(integrator.opts.qmin), qtmp)
            )
        end
        integrator.cache.Q[integrator.cache.n_curr + 1] = q
    end
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        function stepsize_controller_internal!(
                integrator,
                cache::ExtrapolationControllerCache,
                alg::Union{
                    ExtrapolationMidpointHairerWanner,
                    ImplicitHairerWannerExtrapolation,
                    ImplicitEulerExtrapolation,
                    ImplicitEulerBarycentricExtrapolation,
                }
            )
            # Standard step size controller
            # Compute and save the stepsize scaling based on the latest error estimate of the current order
            (; controller) = cache

            return if alg isa
                    Union{
                    ImplicitEulerExtrapolation, ImplicitEulerBarycentricExtrapolation,
                    ImplicitHairerWannerExtrapolation,
                }
                if iszero(integrator.EEst)
                    q = inv(controller.qmax)
                else
                    # Update gamma and beta1
                    if alg isa ImplicitHairerWannerExtrapolation
                        cache.beta1 = typeof(cache.beta1)(
                            1 //
                                (2integrator.cache.n_curr + 1)
                        )
                    elseif alg isa ImplicitEulerExtrapolation
                        cache.beta1 = typeof(cache.beta1)(1 // (integrator.cache.n_curr))
                    else
                        cache.beta1 = typeof(cache.beta1)(
                            1 //
                                (integrator.cache.n_curr - 1)
                        )
                    end
                    cache.gamma = FastPower.fastpower(
                        typeof(cache.gamma)(
                            65 //
                                100
                        ),
                        cache.beta1
                    )
                    # Compute new stepsize scaling
                    qtmp = FastPower.fastpower(integrator.EEst, cache.beta1) /
                        (cache.gamma)
                    @fastmath q = max(
                        inv(controller.qmax),
                        min(inv(controller.qmin), qtmp)
                    )
                end
                integrator.cache.Q[integrator.cache.n_curr + 1] = q
            else
                if iszero(integrator.EEst)
                    q = inv(controller.qmax)
                else
                    # Update gamma and beta1
                    cache.beta1 = typeof(cache.beta1)(1 // (2integrator.cache.n_curr + 1))
                    cache.gamma = FastPower.fastpower(
                        typeof(cache.gamma)(
                            65 //
                                100
                        ),
                        cache.beta1
                    )
                    # Compute new stepsize scaling
                    qtmp = FastPower.fastpower(integrator.EEst, cache.beta1) /
                        cache.gamma
                    @fastmath q = max(
                        inv(controller.qmax),
                        min(inv(controller.qmin), qtmp)
                    )
                end
                integrator.cache.Q[integrator.cache.n_curr + 1] = q
            end
        end
    end
end

function step_accept_controller!(
        integrator,
        alg::Union{
            ExtrapolationMidpointHairerWanner,
            ImplicitHairerWannerExtrapolation,
            ImplicitEulerExtrapolation,
            ImplicitEulerBarycentricExtrapolation,
        }, q
    )
    # Compute new order and stepsize, return new stepsize
    (; min_order, max_order) = alg
    (; n_curr, n_old, Q, sigma, work, dt_new) = integrator.cache
    s = integrator.cache.stage_number

    # Compute new order based on available quantities
    win_min_old = min(n_old, n_curr) - 1 # cf. win_min in perform_step! of the last step
    tmp = win_min_old:(max(n_curr, n_old) + 1) # Index range for the new order
    fill!(dt_new, zero(eltype(dt_new)))
    @.. broadcast = false Q = integrator.dt / Q
    copyto!(dt_new, win_min_old, Q, win_min_old, (max(n_curr, n_old) + 1) - win_min_old + 1)
    @.. broadcast = false Q = integrator.dt / Q
    dtmin = timedepentdtmin(integrator)
    fill!(work, zero(eltype(work))) # work[n] is the work for order (n-1)
    for i in tmp
        work[i] = s[i] / dt_new[i]
    end
    # Order selection
    n_new = n_old
    if n_curr == min_order # Enforce min_order + 1 ≦ n_new
        n_new = min_order + 1
    else
        if n_curr <= n_old
            if work[n_curr - 1] < sigma * work[n_curr]
                n_new = max(n_curr - 1, n_old - 1, min_order + 1) # Enforce min_order + 1≦ n_new
            elseif work[n_curr] < sigma * work[n_curr - 1]
                n_new = min(n_curr + 1, max_order - 1) # Enforce n_new ≦ max_order - 1
            else
                n_new = n_curr # min_order + 1 ≦ n_curr
            end
        else
            if work[n_old] < sigma * work[n_old + 1]
                n_new = max(n_old - 1, min_order + 1)  # Enforce min_order + 1 ≦ n_new
            end
            if work[n_curr + 1] < sigma * work[n_new + 1]
                n_new = min(n_new + 1, max_order - 1) # Enforce n_new ≦ max_order - 1
            end
        end
    end
    integrator.cache.n_curr = n_new

    # Stepsize selection
    if n_new == n_curr + 1
        # Compute the new stepsize of order n_new based on the optimal stepsize of order n_curr
        dt_new[n_new + 1] = s[n_curr + 2] / s[n_curr + 1] * dt_new[n_curr + 1]
        dt_new[n_new + 1] = max(
            dtmin,
            min(abs(integrator.opts.dtmax), abs(dt_new[n_new + 1]))
        )
    end
    return dt_new[n_new + 1]
end

function step_reject_controller!(
        integrator,
        alg::Union{
            ExtrapolationMidpointHairerWanner,
            ImplicitHairerWannerExtrapolation,
            ImplicitEulerExtrapolation,
            ImplicitEulerBarycentricExtrapolation,
        }
    )
    # Compute and save order and stepsize for redoing the current step
    (; n_old, n_curr, Q) = integrator.cache

    # Order selection
    n_red = n_old
    if n_curr == n_old - 1
        n_red = max(alg.min_order + 1, n_old - 1) # Enforce min_order + 1 ≦ n_red
    end
    integrator.cache.n_curr = n_red

    # Stepsize selection
    dt_red = integrator.dt / Q[n_red + 1]
    dtmin = timedepentdtmin(integrator)
    dt_red = integrator.tdir * max(dtmin, min(abs(integrator.opts.dtmax), abs(dt_red))) # Safety scaling
    return integrator.dt = dt_red
end

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

# Run functional tests
if TEST_GROUP != "QA"
    @time @safetestset "Extrapolation Tests" include("ode_extrapolation_tests.jl")
end

if TEST_GROUP == "Multithreading"
    @time @safetestset "Multithreaded Extrapolation Tests" include("multithreading/ode_extrapolation_tests.jl")
end

# Run QA tests (JET, Aqua)
if TEST_GROUP != "Core" && isempty(VERSION.prerelease)
    @time @safetestset "JET Tests" include("jet.jl")
    @time @safetestset "Aqua" include("qa.jl")
end

abstract type OrdinaryDiffEqExtrapolationVarOrderVarStepAlgorithm <:
OrdinaryDiffEqAdaptiveAlgorithm end
abstract type OrdinaryDiffEqImplicitExtrapolationAlgorithm{CS, AD, FDT, ST, CJ} <:
OrdinaryDiffEqAdaptiveImplicitAlgorithm{CS, AD, FDT, ST, CJ} end
reference = """@inproceedings{elrod2022parallelizing,
  title={Parallelizing explicit and implicit extrapolation methods for ordinary differential equations},
  author={Elrod, Chris and Ma, Yingbo and Althaus, Konstantin and Rackauckas, Christopher and others},
  booktitle={2022 IEEE High Performance Extreme Computing Conference (HPEC)},
  pages={1--9},
  year={2022},
  organization={IEEE}}
"""

@doc generic_solver_docstring(
    "Euler extrapolation using Aitken-Neville with the Romberg Sequence.",
    "AitkenNeville",
    "Parallelized Explicit Extrapolation Method.",
    reference,
    """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    """,
    """
    max_order::Int = 10,
    min_order::Int = 1,
    init_order = 3,
    thread = OrdinaryDiffEq.False(),
    """
)
Base.@kwdef struct AitkenNeville{TO} <: OrdinaryDiffEqExtrapolationVarOrderVarStepAlgorithm
    max_order::Int = 10
    min_order::Int = 1
    init_order::Int = 5
    threading::TO = false
end

@doc differentiation_rk_docstring(
    "Extrapolation of implicit Euler method with Romberg sequence.
Similar to Hairer's SEULEX.",
    "ImplicitEulerExtrapolation",
    "Parallelized Explicit Extrapolation Method.",
    references = reference,
    extra_keyword_description = """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    - `sequence`: the step-number sequences, also called the subdividing sequence. Possible values are `:harmonic`, `:romberg` or `:bulirsch`.
    """,
    extra_keyword_default = """
    max_order = 12,
    min_order = 3,
    init_order = 5,
    thread = OrdinaryDiffEq.False(),
    sequence = :harmonic
    """
)
struct ImplicitEulerExtrapolation{CS, AD, F, P, FDT, ST, CJ, TO} <:
    OrdinaryDiffEqImplicitExtrapolationAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    max_order::Int
    min_order::Int
    init_order::Int
    threading::TO
    sequence::Symbol # Name of the subdividing sequence
    autodiff::AD
end

function ImplicitEulerExtrapolation(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(), concrete_jac = nothing,
        diff_type = Val{:forward}(), linsolve = nothing,
        precs = DEFAULT_PRECS,
        max_order = 12, min_order = 3, init_order = 5,
        threading = false, sequence = :harmonic
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    linsolve = (
            linsolve === nothing &&
            (threading == true || threading isa PolyesterThreads)
        ) ?
        RFLUFactorization(; thread = Val(false)) : linsolve

    min_order = max(3, min_order)
    init_order = max(min_order + 1, init_order)
    max_order = max(init_order + 1, max_order)

    # Warn user if orders have been changed
    if (min_order, init_order, max_order) != (min_order, init_order, max_order)
        @warn "The range of extrapolation orders and/or the initial order given to the
          `ImplicitEulerExtrapolation` algorithm are not valid and have been changed:
          Minimal order: " * lpad(min_order, 2, " ") * " --> " * lpad(min_order, 2, " ") *
            "
Maximal order: " * lpad(max_order, 2, " ") * " --> " * lpad(max_order, 2, " ") *
            "
Initial order: " * lpad(init_order, 2, " ") * " --> " * lpad(init_order, 2, " ")
    end

    # Warn user if sequence has been changed:
    if sequence != :harmonic && sequence != :romberg && sequence != :bulirsch
        @warn "The `sequence` given to the `ImplicitEulerExtrapolation` algorithm
            is not valid: it must match `:harmonic`, `:romberg` or `:bulirsch`.
            Thus it has been changed
          :$(sequence) --> :harmonic"
        sequence = :harmonic
    end
    return ImplicitEulerExtrapolation{
        _unwrap_val(chunk_size), typeof(AD_choice),
        typeof(linsolve), typeof(precs), diff_type,
        _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(threading),
    }(
        linsolve, precs, max_order, min_order,
        init_order,
        threading, sequence, AD_choice
    )
end

@doc generic_solver_docstring(
    "Midpoint extrapolation using Barycentric coordinates.",
    "ExtrapolationMidpointDeuflhard",
    "Parallelized Explicit Extrapolation Method.",
    reference,
    """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    - `sequence`: the step-number sequences, also called the subdividing sequence. Possible values are `:harmonic`, `:romberg` or `:bulirsch`.
    - `sequence_factor`: denotes which even multiple of sequence to take while evaluating internal discretizations.
    """,
    """
    max_order = 10,
    min_order = 1,
    init_order = 5,
    thread = OrdinaryDiffEq.True(),
    sequence = :harmonic,
    sequence_factor = 2,
    """
)
struct ExtrapolationMidpointDeuflhard{TO} <:
    OrdinaryDiffEqExtrapolationVarOrderVarStepAlgorithm
    min_order::Int # Minimal extrapolation order
    init_order::Int # Initial extrapolation order
    max_order::Int # Maximal extrapolation order
    sequence::Symbol # Name of the subdividing sequence
    threading::TO
    sequence_factor::Int # An even factor by which sequence is scaled for midpoint extrapolation
end
function ExtrapolationMidpointDeuflhard(;
        min_order = 1, init_order = 5, max_order = 10,
        sequence = :harmonic, threading = true,
        sequence_factor = 2
    )
    # Enforce 1 <=  min_order <= init_order <= max_order:
    min_order = max(1, min_order)
    init_order = max(min_order, init_order)
    max_order = max(init_order, max_order)

    # Warn user if orders have been changed
    if (min_order, init_order, max_order) != (min_order, init_order, max_order)
        @warn "The range of extrapolation orders and/or the initial order given to the
          `ExtrapolationMidpointDeuflhard` algorithm are not valid and have been changed:
          Minimal order: " * lpad(min_order, 2, " ") * " --> " * lpad(min_order, 2, " ") *
            "
Maximal order: " * lpad(max_order, 2, " ") * " --> " * lpad(max_order, 2, " ") *
            "
Initial order: " * lpad(init_order, 2, " ") * " --> " * lpad(init_order, 2, " ")
    end

    # Warn user if sequence_factor is not even
    if sequence_factor % 2 != 0
        @warn "A non-even number cannot be used as sequence factor.
              Thus is has been changed
              $(sequence_factor) --> 2"
        sequence_factor = 2
    end

    # Warn user if sequence has been changed:
    if sequence != :harmonic && sequence != :romberg && sequence != :bulirsch
        @warn "The `sequence` given to the `ExtrapolationMidpointDeuflhard` algorithm
           is not valid: it must match `:harmonic`, `:romberg` or `:bulirsch`.
           Thus it has been changed
          :$(sequence) --> :harmonic"
        sequence = :harmonic
    end

    # Initialize algorithm
    return ExtrapolationMidpointDeuflhard(
        min_order, init_order, max_order, sequence, threading,
        sequence_factor
    )
end

@doc differentiation_rk_docstring(
    "Midpoint extrapolation using Barycentric coordinates.",
    "ImplicitDeuflhardExtrapolation",
    "Parallelized Explicit Extrapolation Method.",
    references = reference,
    extra_keyword_description = """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    - `sequence`: the step-number sequences, also called the subdividing sequence. Possible values are `:harmonic`, `:romberg` or `:bulirsch`.
    """,
    extra_keyword_default = """
    max_order = 10,
    min_order = 1,
    init_order = 5,
    thread = OrdinaryDiffEq.False(),
    sequence = :harmonic,
    """
)
struct ImplicitDeuflhardExtrapolation{CS, AD, F, P, FDT, ST, CJ, TO} <:
    OrdinaryDiffEqImplicitExtrapolationAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    min_order::Int # Minimal extrapolation order
    init_order::Int # Initial extrapolation order
    max_order::Int # Maximal extrapolation order
    sequence::Symbol # Name of the subdividing sequence
    threading::TO
    autodiff::AD
end
function ImplicitDeuflhardExtrapolation(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(), concrete_jac = nothing,
        linsolve = nothing, precs = DEFAULT_PRECS,
        diff_type = Val{:forward}(),
        min_order = 1, init_order = 5, max_order = 10,
        sequence = :harmonic, threading = false
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    # Enforce 1 <=  min_order <= init_order <= max_order:
    min_order = max(1, min_order)
    init_order = max(min_order, init_order)
    max_order = max(init_order, max_order)

    linsolve = (
            linsolve === nothing &&
            (threading == true || threading isa PolyesterThreads)
        ) ?
        RFLUFactorization(; thread = Val(false)) : linsolve

    # Warn user if orders have been changed
    if (min_order, init_order, max_order) != (min_order, init_order, max_order)
        @warn "The range of extrapolation orders and/or the initial order given to the
          `ImplicitDeuflhardExtrapolation` algorithm are not valid and have been changed:
          Minimal order: " * lpad(min_order, 2, " ") * " --> " * lpad(min_order, 2, " ") *
            "
Maximal order: " * lpad(max_order, 2, " ") * " --> " * lpad(max_order, 2, " ") *
            "
Initial order: " * lpad(init_order, 2, " ") * " --> " * lpad(init_order, 2, " ")
        chunk_size
    end

    # Warn user if sequence has been changed:
    if sequence != :harmonic && sequence != :romberg && sequence != :bulirsch
        @warn "The `sequence` given to the `ImplicitDeuflhardExtrapolation` algorithm
           is not valid: it must match `:harmonic`, `:romberg` or `:bulirsch`.
           Thus it has been changed
          :$(sequence) --> :harmonic"
        sequence = :harmonic
    end

    # Initialize algorithm
    return ImplicitDeuflhardExtrapolation{
        _unwrap_val(chunk_size), typeof(AD_choice),
        typeof(linsolve), typeof(precs), diff_type,
        _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(threading),
    }(
        linsolve, precs, min_order,
        init_order, max_order,
        sequence, threading, AD_choice
    )
end

@doc generic_solver_docstring(
    "Midpoint extrapolation using Barycentric coordinates,
    following Hairer's ODEX in the adaptivity behavior.",
    "ExtrapolationMidpointHairerWanner",
    "Parallelized Explicit Extrapolation Method.",
    reference,
    """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    - `sequence`: the step-number sequences, also called the subdividing sequence. Possible values are `:harmonic`, `:romberg` or `:bulirsch`.
    - `sequence_factor`: denotes which even multiple of sequence to take while evaluating internal discretizations.
    """,
    """
    max_order = 10,
    min_order = 2,
    init_order = 5,
    thread = OrdinaryDiffEq.True(),
    sequence = :harmonic,
    sequence_factor = 2,
    """
)
struct ExtrapolationMidpointHairerWanner{TO} <:
    OrdinaryDiffEqExtrapolationVarOrderVarStepAlgorithm
    min_order::Int # Minimal extrapolation order
    init_order::Int # Initial extrapolation order
    max_order::Int # Maximal extrapolation order
    sequence::Symbol # Name of the subdividing sequence
    threading::TO
    sequence_factor::Int # An even factor by which sequence is scaled for midpoint extrapolation
end
function ExtrapolationMidpointHairerWanner(;
        min_order = 2, init_order = 5, max_order = 10,
        sequence = :harmonic, threading = true,
        sequence_factor = 2
    )
    # Enforce 2 <=  min_order
    # and min_order + 1 <= init_order <= max_order - 1:
    min_order = max(2, min_order)
    init_order = max(min_order + 1, init_order)
    max_order = max(init_order + 1, max_order)

    # Warn user if orders have been changed
    if (min_order, init_order, max_order) != (min_order, init_order, max_order)
        @warn "The range of extrapolation orders and/or the initial order given to the
          `ExtrapolationMidpointHairerWanner` algorithm are not valid and have been changed:
          Minimal order: " * lpad(min_order, 2, " ") * " --> " * lpad(min_order, 2, " ") *
            "
Maximal order: " * lpad(max_order, 2, " ") * " --> " * lpad(max_order, 2, " ") *
            "
Initial order: " * lpad(init_order, 2, " ") * " --> " * lpad(init_order, 2, " ")
    end

    # Warn user if sequence_factor is not even
    if sequence_factor % 2 != 0
        @warn "A non-even number cannot be used as sequence factor.
              Thus is has been changed
              $(sequence_factor) --> 2"
        sequence_factor = 2
    end

    # Warn user if sequence has been changed:
    if sequence != :harmonic && sequence != :romberg && sequence != :bulirsch
        @warn "The `sequence` given to the `ExtrapolationMidpointHairerWanner` algorithm
           is not valid: it must match `:harmonic`, `:romberg` or `:bulirsch`.
           Thus it has been changed
          :$(sequence) --> :harmonic"
        sequence = :harmonic
    end

    # Initialize algorithm
    return ExtrapolationMidpointHairerWanner(
        min_order, init_order, max_order, sequence, threading,
        sequence_factor
    )
end

@doc differentiation_rk_docstring(
    "Midpoint extrapolation using Barycentric coordinates,
    following Hairer's SODEX in the adaptivity behavior.",
    "ImplicitHairerWannerExtrapolation",
    "Parallelized Explicit Extrapolation Method.",
    references = reference,
    extra_keyword_description = """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    - `sequence`: the step-number sequences, also called the subdividing sequence. Possible values are `:harmonic`, `:romberg` or `:bulirsch`.
    """,
    extra_keyword_default = """
    max_order = 10,
    min_order = 2,
    init_order = 5,
    thread = OrdinaryDiffEq.False(),
    sequence = :harmonic,
    """
)
struct ImplicitHairerWannerExtrapolation{CS, AD, F, P, FDT, ST, CJ, TO} <:
    OrdinaryDiffEqImplicitExtrapolationAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    min_order::Int # Minimal extrapolation order
    init_order::Int # Initial extrapolation order
    max_order::Int # Maximal extrapolation order
    sequence::Symbol # Name of the subdividing sequence
    threading::TO
    autodiff::AD
end

function ImplicitHairerWannerExtrapolation(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(),
        concrete_jac = nothing,
        linsolve = nothing, precs = DEFAULT_PRECS,
        diff_type = Val{:forward}(),
        min_order = 2, init_order = 5, max_order = 10,
        sequence = :harmonic, threading = false
    )

    # Enforce 2 <=  min_order
    # and min_order + 1 <= init_order <= max_order - 1:
    min_order = max(2, min_order)
    init_order = max(min_order + 1, init_order)
    max_order = max(init_order + 1, max_order)

    linsolve = (
            linsolve === nothing &&
            (threading == true || threading isa PolyesterThreads)
        ) ?
        RFLUFactorization(; thread = Val(false)) : linsolve

    # Warn user if orders have been changed
    if (min_order, init_order, max_order) != (min_order, init_order, max_order)
        @warn "The range of extrapolation orders and/or the initial order given to the
          `ImplicitHairerWannerExtrapolation` algorithm are not valid and have been changed:
          Minimal order: " * lpad(min_order, 2, " ") * " --> " * lpad(min_order, 2, " ") *
            "
Maximal order: " * lpad(max_order, 2, " ") * " --> " * lpad(max_order, 2, " ") *
            "
Initial order: " * lpad(init_order, 2, " ") * " --> " * lpad(init_order, 2, " ")
    end

    # Warn user if sequence has been changed:
    if sequence != :harmonic && sequence != :romberg && sequence != :bulirsch
        @warn "The `sequence` given to the `ImplicitHairerWannerExtrapolation` algorithm
           is not valid: it must match `:harmonic`, `:romberg` or `:bulirsch`.
           Thus it has been changed
          :$(sequence) --> :harmonic"
        sequence = :harmonic
    end

    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)
    # Initialize algorithm
    return ImplicitHairerWannerExtrapolation{
        _unwrap_val(chunk_size), typeof(AD_choice),
        typeof(linsolve), typeof(precs), diff_type,
        _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(threading),
    }(
        linsolve, precs, min_order,
        init_order,
        max_order, sequence, threading, AD_choice
    )
end

@doc differentiation_rk_docstring(
    "Euler extrapolation using Barycentric coordinates,
    following Hairer's SODEX in the adaptivity behavior.",
    "ImplicitEulerBarycentricExtrapolation",
    "Parallelized Explicit Extrapolation Method.",
    references = reference,
    extra_keyword_description = """
    - `max_order`: maximum order of the adaptive order algorithm.
    - `min_order`: minimum order of the adaptive order algorithm.
    - `init_order`: initial order of the adaptive order algorithm.
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    - `sequence`: the step-number sequences, also called the subdividing sequence. Possible values are `:harmonic`, `:romberg` or `:bulirsch`.
    - `sequence_factor`: denotes which even multiple of sequence to take while evaluating internal discretizations.
    """,
    extra_keyword_default = """
    max_order = 10,
    min_order = 3,
    init_order = 5,
    thread = OrdinaryDiffEq.False(),
    sequence = :harmonic,
    sequence_factor = 2,
    """
)
struct ImplicitEulerBarycentricExtrapolation{CS, AD, F, P, FDT, ST, CJ, TO} <:
    OrdinaryDiffEqImplicitExtrapolationAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    min_order::Int # Minimal extrapolation order
    init_order::Int # Initial extrapolation order
    max_order::Int # Maximal extrapolation order
    sequence::Symbol # Name of the subdividing sequence
    threading::TO
    sequence_factor::Int
    autodiff::AD
end

function ImplicitEulerBarycentricExtrapolation(;
        chunk_size = Val{0}(),
        autodiff = AutoForwardDiff(),
        standardtag = Val{true}(),
        concrete_jac = nothing,
        linsolve = nothing, precs = DEFAULT_PRECS,
        diff_type = Val{:forward}(),
        min_order = 3, init_order = 5,
        max_order = 12, sequence = :harmonic,
        threading = false, sequence_factor = 2
    )
    # Enforce 2 <=  min_order
    # and min_order + 1 <= init_order <= max_order - 1:
    min_order = max(3, min_order)
    init_order = max(min_order + 1, init_order)
    max_order = max(init_order + 1, max_order)

    linsolve = (
            linsolve === nothing &&
            (threading == true || threading isa PolyesterThreads)
        ) ?
        RFLUFactorization(; thread = Val(false)) : linsolve

    # Warn user if orders have been changed
    if (min_order, init_order, max_order) != (min_order, init_order, max_order)
        @warn "The range of extrapolation orders and/or the initial order given to the
          `ImplicitEulerBarycentricExtrapolation` algorithm are not valid and have been changed:
          Minimal order: " * lpad(min_order, 2, " ") * " --> " * lpad(min_order, 2, " ") *
            "
Maximal order: " * lpad(max_order, 2, " ") * " --> " * lpad(max_order, 2, " ") *
            "
Initial order: " * lpad(init_order, 2, " ") * " --> " * lpad(init_order, 2, " ")
    end

    # Warn user if sequence has been changed:
    if sequence != :harmonic && sequence != :romberg && sequence != :bulirsch
        @warn "The `sequence` given to the `ImplicitEulerBarycentricExtrapolation` algorithm
           is not valid: it must match `:harmonic`, `:romberg` or `:bulirsch`.
           Thus it has been changed
          :$(sequence) --> :harmonic"
        sequence = :harmonic
    end

    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)
    # Initialize algorithm
    return ImplicitEulerBarycentricExtrapolation{
        _unwrap_val(chunk_size), typeof(AD_choice),
        typeof(linsolve), typeof(precs), diff_type,
        _unwrap_val(standardtag),
        _unwrap_val(concrete_jac), typeof(threading),
    }(
        linsolve,
        precs,
        min_order,
        init_order,
        max_order,
        sequence,
        threading,
        sequence_factor,
        AD_choice
    )
end
